      SUBROUTINE COEFFHN(R,XMH,XMUF,XNF,
     & Sgg0,Sgg1,Sgq1,Sqqb1,Sgg2Ca2,Sgg2CaTfnf,
     & Sgg2CfTfnf,Sgg2rest,
     & Sqg2Cf2,Sqg2CaCf,Sqg2CfTfnf,Sqg2rest,SqqCaCf2,SqqCf3,
     & SqqCf2,Sqqrest,SqqbCaCf2,SqqbCf3,SqqbCf2,SqqbCf2Tfnf,Sqqbrest,
     & Sq1qb2Cf2,Sq1qb2rest,Sq1q2Cf2,Sq1q2rest)

      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16  R,R1,R2,R3,R4,
     &            BN,BN1,BN2,BN3,BN4,B1N,B1N1,B1N2,B1N3,B1N4,
     &            B2N,B2N1,B2N2,B2N3,B2N4,B3N,B3N1,B3N2,B3N3,B3N4,
     &            P0N,P0N1,P0N2,P0N3,P0N4,P1N,P1N1,P1N2,P1N3,P1N4,
     &            P2N,P2N1,P2N2,P2N3,P2N4,P3N,P3N1,P3N2,P3N3,P3N4
      COMPLEX*16 
     & Sgg0,Sgg1,Sgq1,Sqqb1,Sgg2Ca2,Sgg2CaTfnf,Sgg2CfTfnf,Sgg2rest,
     & Sqg2Cf2,Sqg2CaCf,Sqg2CfTfnf,Sqg2rest,SqqCaCf2,SqqCf3,
     & SqqCf2,Sqqrest,SqqbCaCf2,SqqbCf3,SqqbCf2,SqqbCf2Tfnf,Sqqbrest,
     & Sq1qb2Cf2,Sq1qb2rest,Sq1q2Cf2,Sq1q2rest
C
      COMPLEX*16
     &         ACG1,ACG2,ACG3,ACG4,ACG5,ACG6,ACG7,ACG8,ACG9,ACG10,
     &         ACG11,ACG12,ACG13,ACG14,ACG15,ACG16,ACG17,ACG18,ACG19,
     &         ACG20,ACG21,ACG22,ACG23,ACG24,ACG25,ACG26
C     


      CF=4.D0/3.D0
      CA=3.0D0
      XNC=CA
      TF=0.5D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=LOG(XMH2/XMUF2)

C     THE EXPRESSIONS ARE ZERO, BECAUSE OF GB
      CG1=0.0D0
      CG2=0.0D0
      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0
C
       R1=R+1.D0
       R2=R+2.D0
       R3=R+3.D0
       R4=R+4.D0
C      
      CALL PSI0(R,P0N)
      CALL PSI0(R1,P0N1)
      CALL PSI0(R2,P0N2)
      CALL PSI0(R3,P0N3)
      CALL PSI0(R4,P0N4)
      CALL PSI1(R,P1N)
      CALL PSI1(R1,P1N1)
      CALL PSI1(R2,P1N2)
      CALL PSI1(R3,P1N3)
      CALL PSI1(R4,P1N4)
      CALL PSI2(R,P2N)
      CALL PSI2(R1,P2N1)
      CALL PSI2(R2,P2N2)
      CALL PSI2(R3,P2N3)
      CALL PSI2(R4,P2N4)
      CALL PSI3(R,P3N)
      CALL PSI3(R1,P3N1)
      CALL PSI3(R2,P3N2)
      CALL PSI3(R3,P3N3)
      CALL PSI3(R4,P3N4)
C
      CALL BET(R,BN)
      CALL BET(R1,BN1)
      CALL BET(R2,BN2)
      CALL BET(R3,BN3)
      CALL BET(R4,BN4)
      CALL BET1(R,B1N)
      CALL BET1(R1,B1N1)
      CALL BET1(R2,B1N2)
      CALL BET1(R3,B1N3)
      CALL BET1(R4,B1N4)
      CALL BET2(R,B2N)
      CALL BET2(R1,B2N1)
      CALL BET2(R2,B2N2)
      CALL BET2(R3,B2N3)
      CALL BET2(R4,B2N4)
      CALL BET3(R,B3N)
      CALL BET3(R1,B3N1)
      CALL BET3(R2,B3N2)
      CALL BET3(R3,B3N3)
      CALL BET3(R4,B3N4)
    
C
C
      Sgg0=
     & +1.D0

      Sgg1=
     & +GE*CA*XL*(-8.D0)
      Sgg1=Sgg1+GE*CA*(16.D0*P0N+32.D0/(1.D0+R)-16.D0/(2.D0+R)+16.D0/(3.
     &  D0+R))
      Sgg1=Sgg1+GE**2*CA*(8.D0)
      Sgg1=Sgg1+CA*XL*(-8.D0*P0N-16.D0/(1.D0+R)+8.D0/(2.D0+R)-8.D0/(3.D0
     &    +R))
      Sgg1=Sgg1+CA*(-22.D0/3.D0*R**(-1)+16.D0*ZETA2+8.D0*P0N**2+22.D0/(
     &    1.D0+R)+32.D0/(1.D0+R)*P0N2-16.D0/(1.D0+R)/(1.D0+R)-22.D0/(2.D
     &  0+R)-16.D0/(2.D0+R)*P0N3+8.D0/(2.D0+R)/(2.D0+R)+22.D0/3.D0/(3.D0
     &    +R)+16.D0/(3.D0+R)*P0N4-8.D0/(3.D0+R)/(3.D0+R))
      Sgg1=Sgg1+CG1*(2.D0)

      Sgq1=
     & +GE*CF*(-8.D0*R**(-1)+8.D0/(1.D0+R)-4.D0/(2.D0+R))
      Sgq1=Sgq1+CF*XL*(4.D0*R**(-1)-4.D0/(1.D0+R)+2.D0/(2.D0+R))
      Sgq1=Sgq1+CF*(4.D0*R**(-2)-8.D0*R**(-1)*P0N1-3.D0*R**(-1)+6.D0/(1.
     &  D0+R)+8.D0/(1.D0+R)*P0N2-4.D0/(1.D0+R)/(1.D0+R)-1/(2.D0+R)-4.D0
     &    /(2.D0+R)*P0N3+2.D0/(2.D0+R)/(2.D0+R))

      Sqqb1=
     & +CF**2*(8.D0/3.D0*R**(-1)-8.D0/(1.D0+R)+8.D0/(2.D0+R)-8.D0/3.D0
     &    /(3.D0+R))

      Sgg2Ca2=
     & +GE*XL*(-536.D0/9.D0+528.D0*R**(-1)-112.D0*ZETA2-176.D0/3.D0*P0N
     &    -192.D0*P0N**2-32.D0*P1N-32.D0*B1N-2032.D0/3.D0/(1.D0+R)-768.D
     &  0/(1.D0+R)*P0N2+192.D0/(1.D0+R)/(1.D0+R)+1856.D0/3.D0/(2.D0+R)+
     &    384.D0/(2.D0+R)*P0N3-480.D0/(2.D0+R)/(2.D0+R)-1760.D0/3.D0/(3.
     &  D0+R)-384.D0/(3.D0+R)*P0N4+224.D0/(3.D0+R)/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+GE*XL**2*(44.D0/3.D0+64.D0*P0N+128.D0/(1.D0+R)-64.
     &  D0/(2.D0+R)+64.D0/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+GE*(1616.D0/27.D0+1232.D0/3.D0*R**(-2)-1056.D0*
     &    R**(-1)*P0N1+16.D0*R**(-1)*P1N1-48.D0*R**(-1)*B1N1-8108.D0/9.D
     &  0*R**(-1)+224.D0*ZETA2*P0N+32.D0*ZETA2*BN-56.D0*ZETA3+104.D0*
     &    P0N*P1N+96.D0*P0N*B1N+1072.D0/9.D0*P0N+176.D0/3.D0*P0N**2+128.
     &  D0*P0N**3+44.D0/3.D0*P1N-4.D0*P2N+8.D0*B2N+8636.D0/9.D0/(1.D0+R
     &    )+448.D0/(1.D0+R)*ZETA2+4064.D0/3.D0/(1.D0+R)*P0N2+768.D0/(1.D
     &  0+R)*P0N2**2+192.D0/(1.D0+R)*P1N2+144.D0/(1.D0+R)*B1N2-2144.D0/
     &    3.D0/(1.D0+R)/(1.D0+R)-480.D0/(1.D0+R)/(1.D0+R)*P0N2+192.D0/(
     &    1.D0+R)/(1.D0+R)/(1.D0+R)-7576.D0/9.D0/(2.D0+R)-224.D0/(2.D0+
     &    R)*ZETA2-3712.D0/3.D0/(2.D0+R)*P0N3-384.D0/(2.D0+R)*P0N3**2-
     &    72.D0/(2.D0+R)*P1N3+2848.D0/3.D0/(2.D0+R)/(2.D0+R)+1008.D0/(2.
     &  D0+R)/(2.D0+R)*P0N3-608.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)+1020.D0/(
     &    3.D0+R)+224.D0/(3.D0+R)*ZETA2+3520.D0/3.D0/(3.D0+R)*P0N4+384.D
     &  0/(3.D0+R)*P0N4**2+88.D0/(3.D0+R)*P1N4-2992.D0/3.D0/(3.D0+R)/(3.
     &  D0+R)-496.D0/(3.D0+R)/(3.D0+R)*P0N4+288.D0/(3.D0+R)/(3.D0+R)/(3.
     &  D0+R))
      Sgg2Ca2=Sgg2Ca2+GE**2*XL*(-88.D0/3.D0-192.D0*P0N-384.D0/(1.D0+R)+
     &    192.D0/(2.D0+R)-192.D0/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+GE**2*XL**2*(32.D0)
      Sgg2Ca2=Sgg2Ca2+GE**2*(536.D0/9.D0-528.D0*R**(-1)+112.D0*ZETA2+
     &    176.D0/3.D0*P0N+192.D0*P0N**2+52.D0*P1N+48.D0*B1N+2032.D0/3.D0
     &    /(1.D0+R)+768.D0/(1.D0+R)*P0N2-240.D0/(1.D0+R)/(1.D0+R)-1856.D
     &  0/3.D0/(2.D0+R)-384.D0/(2.D0+R)*P0N3+504.D0/(2.D0+R)/(2.D0+R)+
     &    1760.D0/3.D0/(3.D0+R)+384.D0/(3.D0+R)*P0N4-248.D0/(3.D0+R)/(3.
     &  D0+R))
      Sgg2Ca2=Sgg2Ca2+GE**3*XL*(-64.D0)
      Sgg2Ca2=Sgg2Ca2+GE**3*(176.D0/9.D0+128.D0*P0N+256.D0/(1.D0+R)-128.
     &  D0/(2.D0+R)+128.D0/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+GE**4*(32.D0)
      Sgg2Ca2=Sgg2Ca2+XL*(-24.D0-176.D0*R**(-2)+528.D0*R**(-1)*P0N1+
     &    1262.D0/3.D0*R**(-1)-112.D0*ZETA2*P0N-32.D0*ZETA2*BN-176.D0/3.
     &  D0*ZETA2+24.D0*ZETA3-32.D0*P0N*P1N-32.D0*P0N*B1N-536.D0/9.D0*
     &    P0N-88.D0/3.D0*P0N**2-64.D0*P0N**3+8.D0*P2N+8.D0*B2N-3562.D0/
     &    9.D0/(1.D0+R)-224.D0/(1.D0+R)*ZETA2-2032.D0/3.D0/(1.D0+R)*
     &    P0N2-384.D0/(1.D0+R)*P0N2**2-64.D0/(1.D0+R)*P1N2-64.D0/(1.D0+
     &    R)*B1N2+904.D0/3.D0/(1.D0+R)/(1.D0+R)+192.D0/(1.D0+R)/(1.D0+R
     &    )*P0N2+3026.D0/9.D0/(2.D0+R)+112.D0/(2.D0+R)*ZETA2+1856.D0/3.D
     &  0/(2.D0+R)*P0N3+192.D0/(2.D0+R)*P0N3**2+32.D0/(2.D0+R)*P1N3-32.D
     &  0/(2.D0+R)*B1N3-1328.D0/3.D0/(2.D0+R)/(2.D0+R)-480.D0/(2.D0+R)
     &    /(2.D0+R)*P0N3+256.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)-4322.D0/9.D0
     &    /(3.D0+R)-112.D0/(3.D0+R)*ZETA2-1760.D0/3.D0/(3.D0+R)*P0N4-
     &    192.D0/(3.D0+R)*P0N4**2-32.D0/(3.D0+R)*P1N4-32.D0/(3.D0+R)*
     &    B1N4+1496.D0/3.D0/(3.D0+R)/(3.D0+R)+224.D0/(3.D0+R)/(3.D0+R)*
     &    P0N4-96.D0/(3.D0+R)/(3.D0+R)/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+XL**2*(-352.D0/3.D0*R**(-1)+44.D0/3.D0*P0N+32.D0*
     &    P0N**2+376.D0/3.D0/(1.D0+R)+128.D0/(1.D0+R)*P0N2-332.D0/3.D0
     &    /(2.D0+R)-64.D0/(2.D0+R)*P0N3+96.D0/(2.D0+R)/(2.D0+R)+132.D0
     &    /(3.D0+R)+64.D0/(3.D0+R)*P0N4-32.D0/(3.D0+R)/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+ACG3(-1.D0+R)*GE*(-32.D0)
      Sgg2Ca2=Sgg2Ca2+ACG3(-1.D0+R)*XL*(32.D0)
      Sgg2Ca2=Sgg2Ca2+ACG3(-1.D0+R)*(-32.D0*P0N)
      Sgg2Ca2=Sgg2Ca2+ACG3(1.D0+R)*(-16.D0/(1.D0+R))
      Sgg2Ca2=Sgg2Ca2+ACG3(2.D0+R)*(64.D0/(2.D0+R))
      Sgg2Ca2=Sgg2Ca2+ACG3(3.D0+R)*(64.D0/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+ACG3(R)*(48.D0*R**(-1))
      Sgg2Ca2=Sgg2Ca2+ACG5(-1.D0+R)*(-32.D0)
      Sgg2Ca2=Sgg2Ca2+ACG8(-1.D0+R)*(-32.D0)
      Sgg2Ca2=Sgg2Ca2+ACG18(-1.D0+R)*GE*(8.D0)
      Sgg2Ca2=Sgg2Ca2+ACG18(-1.D0+R)*(-44.D0/3.D0+8.D0*P0N)
      Sgg2Ca2=Sgg2Ca2+ACG18(1.D0+R)*(32.D0/(1.D0+R))
      Sgg2Ca2=Sgg2Ca2+ACG18(2.D0+R)*(-40.D0/(2.D0+R))
      Sgg2Ca2=Sgg2Ca2+ACG18(3.D0+R)*(24.D0/(3.D0+R))
      Sgg2Ca2=Sgg2Ca2+ACG18(R)*(-16.D0*R**(-1))
      Sgg2Ca2=Sgg2Ca2+ACG21(-1.D0+R)*(-8.D0)
      Sgg2Ca2=Sgg2Ca2+ACG22(-1.D0+R)*(12.D0)
      Sgg2Ca2=Sgg2Ca2+93.D0-16.D0*R**(-4)-572.D0/3.D0*R**(-3)+1232.D0/3.
     &  D0*R**(-2)*P0N1-8.D0*R**(-2)*P1N1+16.D0*R**(-2)*B1N1+3602.D0/9.D
     &  0*R**(-2)-48.D0*R**(-1)*ZETA2*BN1-308.D0/3.D0*R**(-1)*ZETA2+16.D
     &  0*R**(-1)*P0N1*P1N1-48.D0*R**(-1)*P0N1*B1N1-8108.D0/9.D0*
     &    R**(-1)*P0N1-528.D0*R**(-1)*P0N1**2-760.D0/3.D0*R**(-1)*P1N1+
     &    8.D0*R**(-1)*P2N1+112.D0/3.D0*R**(-1)*B1N1+4.D0*R**(-1)*B2N1-
     &    16705.D0/27.D0*R**(-1)+32.D0*ZETA2*P0N*BN+112.D0*ZETA2*P0N**2
     &    -16.D0*ZETA2*P1N+32.D0*ZETA2*B1N+1072.D0/9.D0*ZETA2+92.D0*
     &    ZETA2**2-56.D0*ZETA3*P0N+16.D0*ZETA3*BN-308.D0/9.D0*ZETA3+44.D
     &  0/3.D0*P0N*P1N-4.D0*P0N*P2N+8.D0*P0N*B2N+1616.D0/27.D0*P0N+52.D0
     &    *P0N**2*P1N+48.D0*P0N**2*B1N+536.D0/9.D0*P0N**2+176.D0/9.D0*
     &    P0N**3+32.D0*P0N**4-2.D0*P1N**2-88.D0/9.D0*P2N+19.D0/3.D0*P3N
     &    -16.D0/3.D0*B3N+16.D0*ACG6(-1.D0+R)+18523.D0/27.D0/(1.D0+R)+
     &    448.D0/(1.D0+R)*ZETA2*P0N2+16.D0/(1.D0+R)*ZETA2*BN2+308.D0/(1.
     &  D0+R)*ZETA2-112.D0/(1.D0+R)*ZETA3+192.D0/(1.D0+R)*P0N2*P1N2+144.
     &  D0/(
     & 1.D0+R)*P0N2*B1N2+8636.D0/9.D0/(1.D0+R)*P0N2+2032.D0/3.D0/(1.D0+
     &    R)*P0N2**2+256.D0/(1.D0+R)*P0N2**3+192.D0/(1.D0+R)*P1N2-16.D0
     &    /(1.D0+R)*P2N2+32.D0/(1.D0+R)*B1N2+20.D0/(1.D0+R)*B2N2-2188.D0
     &  /3.D0/(1.D0+R)/(1.D0+R)-208.D0/(1.D0+R)/(1.D0+R)*ZETA2-2144.D0/
     &    3.D0/(1.D0+R)/(1.D0+R)*P0N2-240.D0/(1.D0+R)/(1.D0+R)*P0N2**2+
     &    40.D0/(1.D0+R)/(1.D0+R)*P1N2-80.D0/(1.D0+R)/(1.D0+R)*B1N2+328.
     &  D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+192.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)
     &    *P0N2-32.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)/(1.D0+R)-19751.D0/27.D0
     &    /(2.D0+R)-224.D0/(2.D0+R)*ZETA2*P0N3-64.D0/(2.D0+R)*ZETA2*BN3
     &    -308.D0/(2.D0+R)*ZETA2+56.D0/(2.D0+R)*ZETA3-72.D0/(2.D0+R)*
     &    P0N3*P1N3-7576.D0/9.D0/(2.D0+R)*P0N3-1856.D0/3.D0/(2.D0+R)*
     &    P0N3**2-128.D0/(2.D0+R)*P0N3**3-148.D0/(2.D0+R)*P1N3+20.D0/(2.
     &  D0+R)*P2N3-56.D0/(2.D0+R)*B1N3+16.D0/(2.D0+R)*B2N3+1582.D0/3.D0
     &    /(2.D0+R)/(2.D0+R)+104.D0/(2.D0+R)/(2.D0+R)*ZETA2+2848.D0/3.D0
     &    /(2.D0+R)/(2.D0+R)*P0N3+504.D0/(2.D0+R)/(2.D0+R)*P0N3**2+192.D
     &  0/(
     & 2.D0+R)/(2.D0+R)*P1N3-16.D0/(2.D0+R)/(2.D0+R)*B1N3-604.D0/(2.D0+
     &    R)/(2.D0+R)/(2.D0+R)-608.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)*P0N3+
     &    272.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)/(2.D0+R)+7055.D0/9.D0/(3.D0
     &    +R)+224.D0/(3.D0+R)*ZETA2*P0N4-64.D0/(3.D0+R)*ZETA2*BN4+308.D0
     &  /3.D0/(3.D0+R)*ZETA2-56.D0/(3.D0+R)*ZETA3+88.D0/(3.D0+R)*P0N4*
     &    P1N4+1020.D0/(3.D0+R)*P0N4+1760.D0/3.D0/(3.D0+R)*P0N4**2+128.D
     &  0/(3.D0+R)*P0N4**3+220.D0/(3.D0+R)*P1N4-12.D0/(3.D0+R)*P2N4-88.D
     &  0/3.D0/(3.D0+R)*B1N4+16.D0/(3.D0+R)*B2N4-8108.D0/9.D0/(3.D0+R)
     &    /(3.D0+R)-104.D0/(3.D0+R)/(3.D0+R)*ZETA2-2992.D0/3.D0/(3.D0+R
     &    )/(3.D0+R)*P0N4-248.D0/(3.D0+R)/(3.D0+R)*P0N4**2-48.D0/(3.D0+
     &    R)/(3.D0+R)*P1N4-48.D0/(3.D0+R)/(3.D0+R)*B1N4+1496.D0/3.D0/(3.
     &  D0+R)/(3.D0+R)/(3.D0+R)+288.D0/(3.D0+R)/(3.D0+R)/(3.D0+R)*P0N4-
     &    144.D0/(3.D0+R)/(3.D0+R)/(3.D0+R)/(3.D0+R)

      Sgg2CaTfnf=
     & +GE*XL*(160.D0/9.D0+64.D0/3.D0*P0N+128.D0/3.D0/(1.D0+R)-64.D0/3.D
     &  0/(2.D0+R)+64.D0/3.D0/(3.D0+R))
      Sgg2CaTfnf=Sgg2CaTfnf+GE*XL**2*(-16.D0/3.D0)
      Sgg2CaTfnf=Sgg2CaTfnf+GE*(-448.D0/27.D0+16.D0*R**(-1)*P1N1+592.D0/
     &    9.D0*R**(-1)-320.D0/9.D0*P0N-64.D0/3.D0*P0N**2-16.D0/3.D0*P1N
     &    -1456.D0/9.D0/(1.D0+R)-256.D0/3.D0/(1.D0+R)*P0N2-16.D0/(1.D0+
     &    R)*P1N2+64.D0/3.D0/(1.D0+R)/(1.D0+R)+1160.D0/9.D0/(2.D0+R)+
     &    128.D0/3.D0/(2.D0+R)*P0N3+8.D0/(2.D0+R)*P1N3-128.D0/3.D0/(2.D0
     &    +R)/(2.D0+R)-304.D0/3.D0/(3.D0+R)-128.D0/3.D0/(3.D0+R)*P0N4+
     &    64.D0/3.D0/(3.D0+R)/(3.D0+R))
      Sgg2CaTfnf=Sgg2CaTfnf+GE**2*XL*(32.D0/3.D0)
      Sgg2CaTfnf=Sgg2CaTfnf+GE**2*(-160.D0/9.D0-64.D0/3.D0*P0N-128.D0/3.
     &  D0/(1.D0+R)+64.D0/3.D0/(2.D0+R)-64.D0/3.D0/(3.D0+R))
      Sgg2CaTfnf=Sgg2CaTfnf+GE**3*(-64.D0/9.D0)
      Sgg2CaTfnf=Sgg2CaTfnf+XL*(16.D0-296.D0/9.D0*R**(-1)+64.D0/3.D0*
     &    ZETA2+160.D0/9.D0*P0N+32.D0/3.D0*P0N**2+728.D0/9.D0/(1.D0+R)+
     &    128.D0/3.D0/(1.D0+R)*P0N2-32.D0/3.D0/(1.D0+R)/(1.D0+R)-568.D0/
     &    9.D0/(2.D0+R)-64.D0/3.D0/(2.D0+R)*P0N3+64.D0/3.D0/(2.D0+R)/(2.
     &  D0+R)+152.D0/3.D0/(3.D0+R)+64.D0/3.D0/(3.D0+R)*P0N4-32.D0/3.D0
     &    /(3.D0+R)/(3.D0+R))
      Sgg2CaTfnf=Sgg2CaTfnf+XL**2*(-16.D0/3.D0*P0N-32.D0/3.D0/(1.D0+R)+
     &    16.D0/3.D0/(2.D0+R)-16.D0/3.D0/(3.D0+R))
      Sgg2CaTfnf=Sgg2CaTfnf+ACG18(-1.D0+R)*(16.D0/3.D0)
      Sgg2CaTfnf=Sgg2CaTfnf+ACG18(1.D0+R)*(16.D0/(1.D0+R))
      Sgg2CaTfnf=Sgg2CaTfnf+ACG18(2.D0+R)*(-8.D0/(2.D0+R))
      Sgg2CaTfnf=Sgg2CaTfnf+ACG18(R)*(-16.D0*R**(-1))
      Sgg2CaTfnf=Sgg2CaTfnf-2024.D0/27.D0+16.D0/3.D0*R**(-3)-296.D0/9.D0
     &    *R**(-2)+16.D0*R**(-1)*P0N1*P1N1+592.D0/9.D0*R**(-1)*P0N1+16.D
     &  0/3.D0*R**(-1)*P1N1+3142.D0/27.D0*R**(-1)-320.D0/9.D0*ZETA2-16.D
     &  0/3.D0*ZETA3-16.D0/3.D0*P0N*P1N-448.D0/27.D0*P0N-160.D0/9.D0*
     &    P0N**2-64.D0/9.D0*P0N**3+32.D0/9.D0*P2N-6188.D0/27.D0/(1.D0+R
     &    )-16.D0/(1.D0+R)*P0N2*P1N2-1456.D0/9.D0/(1.D0+R)*P0N2-128.D0/
     &    3.D0/(1.D0+R)*P0N2**2-32.D0/(1.D0+R)*P1N2+208.D0/3.D0/(1.D0+R
     &    )/(1.D0+R)+64.D0/3.D0/(1.D0+R)/(1.D0+R)*P0N2-16.D0/(1.D0+R)/(
     &    1.D0+R)/(1.D0+R)+5218.D0/27.D0/(2.D0+R)+8.D0/(2.D0+R)*P0N3*
     &    P1N3+1160.D0/9.D0/(2.D0+R)*P0N3+64.D0/3.D0/(2.D0+R)*P0N3**2+
     &    24.D0/(2.D0+R)*P1N3-268.D0/3.D0/(2.D0+R)/(2.D0+R)-128.D0/3.D0
     &    /(2.D0+R)/(2.D0+R)*P0N3+40.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)-3068.
     &  D0/27.D0/(3.D0+R)-304.D0/3.D0/(3.D0+R)*P0N4-64.D0/3.D0/(3.D0+R)
     &    *P0N4**2-32.D0/3.D0/(3.D0+R)*P1N4+64.D0/(3.D0+R)/(3.D0+R)+64.D
     &  0/3.D0/(3.D0+R)/(3.D0+R)*P0N4-32.D0/3.D0/(3.D0+R)/(3.D0+R)/(3.D0
     &    +R)

      Sgg2CfTfnf=
     & +GE*XL*(-128.D0/3.D0*R**(-1)-32.D0/(1.D0+R)+64.D0/(1.D0+R)/(1.D0
     &    +R)+32.D0/(2.D0+R)+64.D0/(2.D0+R)/(2.D0+R)+128.D0/3.D0/(3.D0+
     &    R))
      Sgg2CfTfnf=Sgg2CfTfnf+GE*(-128.D0/3.D0*R**(-2)+256.D0/3.D0*
     &    R**(-1)*P0N1-32.D0*R**(-1)*P1N1+512.D0/9.D0*R**(-1)+896.D0/3.D
     &  0/(1.D0+R)+64.D0/(1.D0+R)*P0N2+32.D0/(1.D0+R)*P1N2-128.D0/(1.D0
     &    +R)/(1.D0+R)-128.D0/(1.D0+R)/(1.D0+R)*P0N2+128.D0/(1.D0+R)/(1.
     &  D0+R)/(1.D0+R)-704.D0/3.D0/(2.D0+R)-64.D0/(2.D0+R)*P0N3-16.D0/(
     &    2.D0+R)*P1N3-96.D0/(2.D0+R)/(2.D0+R)-128.D0/(2.D0+R)/(2.D0+R)
     &    *P0N3+128.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)-1088.D0/9.D0/(3.D0+R)
     &    -256.D0/3.D0/(3.D0+R)*P0N4+256.D0/3.D0/(3.D0+R)/(3.D0+R))
      Sgg2CfTfnf=Sgg2CfTfnf+GE**2*(128.D0/3.D0*R**(-1)+32.D0/(1.D0+R)-
     &    64.D0/(1.D0+R)/(1.D0+R)-32.D0/(2.D0+R)-64.D0/(2.D0+R)/(2.D0+R
     &    )-128.D0/3.D0/(3.D0+R))
      Sgg2CfTfnf=Sgg2CfTfnf+XL*(8.D0+64.D0/3.D0*R**(-2)-128.D0/3.D0*
     &    R**(-1)*P0N1-256.D0/9.D0*R**(-1)-448.D0/3.D0/(1.D0+R)-32.D0/(
     &    1.D0+R)*P0N2+64.D0/(1.D0+R)/(1.D0+R)+64.D0/(1.D0+R)/(1.D0+R)*
     &    P0N2-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+352.D0/3.D0/(2.D0+R)+32.
     &  D0/(2.D0+R)*P0N3+48.D0/(2.D0+R)/(2.D0+R)+64.D0/(2.D0+R)/(2.D0+R
     &    )*P0N3-64.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)+544.D0/9.D0/(3.D0+R)+
     &    128.D0/3.D0/(3.D0+R)*P0N4-128.D0/3.D0/(3.D0+R)/(3.D0+R))
      Sgg2CfTfnf=Sgg2CfTfnf+XL**2*(32.D0/3.D0*R**(-1)+8.D0/(1.D0+R)-16.D
     &  0/(1.D0+R)/(1.D0+R)-8.D0/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R)-32.D0/
     &    3.D0/(3.D0+R))
      Sgg2CfTfnf=Sgg2CfTfnf+ACG18(1.D0+R)*(-32.D0/(1.D0+R))
      Sgg2CfTfnf=Sgg2CfTfnf+ACG18(2.D0+R)*(16.D0/(2.D0+R))
      Sgg2CfTfnf=Sgg2CfTfnf+ACG18(R)*(32.D0*R**(-1))
      Sgg2CfTfnf=Sgg2CfTfnf+4.D0+64.D0/3.D0*R**(-3)-128.D0/3.D0*R**(-2)
     &    *P0N1-256.D0/9.D0*R**(-2)-32.D0*R**(-1)*P0N1*P1N1+512.D0/9.D0
     &    *R**(-1)*P0N1+128.D0/3.D0*R**(-1)*P0N1**2+64.D0/3.D0*R**(-1)*
     &    P1N1-608.D0/27.D0*R**(-1)+4144.D0/9.D0/(1.D0+R)+32.D0/(1.D0+R
     &    )*P0N2*P1N2+896.D0/3.D0/(1.D0+R)*P0N2+32.D0/(1.D0+R)*P0N2**2+
     &    48.D0/(1.D0+R)*P1N2-192.D0/(1.D0+R)/(1.D0+R)-128.D0/(1.D0+R)
     &    /(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)*P0N2**2-32.D0/(1.D0+R)
     &    /(1.D0+R)*P1N2+104.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+128.D0/(1.D0
     &    +R)/(1.D0+R)/(1.D0+R)*P0N2-80.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)/(
     &    1.D0+R)-3280.D0/9.D0/(2.D0+R)-16.D0/(2.D0+R)*P0N3*P1N3-704.D0/
     &    3.D0/(2.D0+R)*P0N3-32.D0/(2.D0+R)*P0N3**2-32.D0/(2.D0+R)*P1N3
     &    +128.D0/(2.D0+R)/(2.D0+R)-96.D0/(2.D0+R)/(2.D0+R)*P0N3-64.D0
     &    /(2.D0+R)/(2.D0+R)*P0N3**2-32.D0/(2.D0+R)/(2.D0+R)*P1N3+56.D0
     &    /(2.D0+R)/(2.D0+R)/(2.D0+R)+128.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)
     &    *P0N3-80.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)/(2.D0+R)-1984.D0/27.D0
     &    /(
     & 3.D0+R)-1088.D0/9.D0/(3.D0+R)*P0N4-128.D0/3.D0/(3.D0+R)*P0N4**2-
     &    64.D0/3.D0/(3.D0+R)*P1N4+1088.D0/9.D0/(3.D0+R)/(3.D0+R)+256.D0
     &  /3.D0/(3.D0+R)/(3.D0+R)*P0N4-64.D0/(3.D0+R)/(3.D0+R)/(3.D0+R)

      Sgg2rest=
     & +GE*CA*XL*CG1*(-16.D0)
      Sgg2rest=Sgg2rest+GE*CA*CG1*(32.D0*P0N+64.D0/(1.D0+R)-32.D0/(2.D0
     &    +R)+32.D0/(3.D0+R))
      Sgg2rest=Sgg2rest+GE**2*CA*CG1*(16.D0)
      Sgg2rest=Sgg2rest+CA*XL*CG1*(-16.D0*P0N-32.D0/(1.D0+R)+16.D0/(2.D0
     &    +R)-16.D0/(3.D0+R))
      Sgg2rest=Sgg2rest+CA*CG1*(-44.D0/3.D0*R**(-1)+32.D0*ZETA2+16.D0*
     &    P0N**2+44.D0/(1.D0+R)+64.D0/(1.D0+R)*P0N2-32.D0/(1.D0+R)/(1.D0
     &    +R)-44.D0/(2.D0+R)-32.D0/(2.D0+R)*P0N3+16.D0/(2.D0+R)/(2.D0+R
     &    )+44.D0/3.D0/(3.D0+R)+32.D0/(3.D0+R)*P0N4-16.D0/(3.D0+R)/(3.D0
     &    +R))
      Sgg2rest=Sgg2rest+CG1**2*(1.D0)
      Sgg2rest=Sgg2rest+CG2*(2.D0)
      
      Sqg2Cf2=
     & +GE*XL*(-16.D0*R**(-2)+48.D0*R**(-1)*P0N1+36.D0*R**(-1)-64.D0/(1.
     &  D0+R)-48.D0/(1.D0+R)*P0N2+32.D0/(1.D0+R)/(1.D0+R)+28.D0/(2.D0+R
     &    )+24.D0/(2.D0+R)*P0N3-16.D0/(2.D0+R)/(2.D0+R))
      Sqg2Cf2=Sqg2Cf2+GE*XL**2*(-8.D0*R**(-1)+8.D0/(1.D0+R)-4.D0/(2.D0+
     &    R))
      Sqg2Cf2=Sqg2Cf2+GE*(-16.D0*R**(-3)+48.D0*R**(-2)*P0N1+36.D0*
     &    R**(-2)+12.D0*R**(-1)*ZETA2-120.D0*R**(-1)*P0N1-52.D0*R**(-1)
     &    *P0N1**2-12.D0*R**(-1)*P1N1-878.D0/9.D0*R**(-1)+144.D0/(1.D0+
     &    R)-12.D0/(1.D0+R)*ZETA2+188.D0/(1.D0+R)*P0N2+52.D0/(1.D0+R)*
     &    P0N2**2+12.D0/(1.D0+R)*P1N2-56.D0/(1.D0+R)/(1.D0+R)-80.D0/(1.D
     &  0+R)/(1.D0+R)*P0N2+48.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)-48.D0/(2.D0
     &    +R)+6.D0/(2.D0+R)*ZETA2-90.D0/(2.D0+R)*P0N3-26.D0/(2.D0+R)*
     &    P0N3**2-6.D0/(2.D0+R)*P1N3+88.D0/(2.D0+R)/(2.D0+R)+40.D0/(2.D0
     &    +R)/(2.D0+R)*P0N3-24.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)+248.D0/9.D0
     &    /(3.D0+R)+32.D0/3.D0/(3.D0+R)/(3.D0+R))
      Sqg2Cf2=Sqg2Cf2+GE**2*XL*(24.D0*R**(-1)-24.D0/(1.D0+R)+12.D0/(2.D0
     &    +R))
      Sqg2Cf2=Sqg2Cf2+GE**2*(24.D0*R**(-2)-52.D0*R**(-1)*P0N1-60.D0*
     &    R**(-1)+94.D0/(1.D0+R)+52.D0/(1.D0+R)*P0N2-40.D0/(1.D0+R)/(1.D
     &  0+R)-45.D0/(2.D0+R)-26.D0/(2.D0+R)*P0N3+20.D0/(2.D0+R)/(2.D0+R)
     &    )
      Sqg2Cf2=Sqg2Cf2+GE**3*(-52.D0/3.D0*R**(-1)+52.D0/3.D0/(1.D0+R)-26.
     &  D0/3.D0/(2.D0+R))
      Sqg2Cf2=Sqg2Cf2+XL*(-16.D0*R**(-2)*P0N1-8.D0*R**(-1)*ZETA2+36.D0*
     &    R**(-1)*P0N1+24.D0*R**(-1)*P0N1**2+8.D0*R**(-1)*P1N1+106.D0/9.
     &  D0*R**(-1)-12.D0/(1.D0+R)+8.D0/(1.D0+R)*ZETA2-64.D0/(1.D0+R)*
     &    P0N2-24.D0/(1.D0+R)*P0N2**2-8.D0/(1.D0+R)*P1N2+8.D0/(1.D0+R)
     &    /(1.D0+R)+32.D0/(1.D0+R)/(1.D0+R)*P0N2-16.D0/(1.D0+R)/(1.D0+R
     &    )/(1.D0+R)-4.D0/(2.D0+R)-4.D0/(2.D0+R)*ZETA2+28.D0/(2.D0+R)*
     &    P0N3+12.D0/(2.D0+R)*P0N3**2+4.D0/(2.D0+R)*P1N3-38.D0/(2.D0+R)
     &    /(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R)*P0N3+8.D0/(2.D0+R)/(2.D0+R)
     &    /(2.D0+R)-124.D0/9.D0/(3.D0+R)-16.D0/3.D0/(3.D0+R)/(3.D0+R))
      Sqg2Cf2=Sqg2Cf2+XL**2*(-8.D0*R**(-1)*P0N1+4.D0/(1.D0+R)+8.D0/(1.D0
     &    +R)*P0N2-4.D0/(1.D0+R)/(1.D0+R)-1/(2.D0+R)-4.D0/(2.D0+R)*P0N3
     &    +2.D0/(2.D0+R)/(2.D0+R))
      Sqg2Cf2=Sqg2Cf2-16.D0*R**(-3)*P0N1-8.D0*R**(-2)*ZETA2+36.D0*
     &    R**(-2)*P0N1+24.D0*R**(-2)*P0N1**2+8.D0*R**(-2)*P1N1+106.D0/9.
     &  D0*R**(-2)+12.D0*R**(-1)*ZETA2*P0N1+12.D0*R**(-1)*ZETA2-8.D0/3.D
     &  0*R**(-1)*ZETA3-12.D0*R**(-1)*P0N1*P1N1-878.D0/9.D0*R**(-1)*
     &    P0N1-60.D0*R**(-1)*P0N1**2-52.D0/3.D0*R**(-1)*P0N1**3-20.D0/3.
     &  D0*R**(-1)*P1N1+20.D0/3.D0*R**(-1)*P2N1-32.D0/3.D0*R**(-1)*B1N1
     &    -1393.D0/54.D0*R**(-1)-130.D0/9.D0/(1.D0+R)-12.D0/(1.D0+R)*
     &    ZETA2*P0N2-18.D0/(1.D0+R)*ZETA2+8.D0/3.D0/(1.D0+R)*ZETA3+12.D0
     &    /(1.D0+R)*P0N2*P1N2+144.D0/(1.D0+R)*P0N2+94.D0/(1.D0+R)*
     &    P0N2**2+52.D0/3.D0/(1.D0+R)*P0N2**3+18.D0/(1.D0+R)*P1N2-20.D0/
     &    3.D0/(1.D0+R)*P2N2-16.D0/(1.D0+R)*B1N2-69.D0/(1.D0+R)/(1.D0+R
     &    )+8.D0/(1.D0+R)/(1.D0+R)*ZETA2-56.D0/(1.D0+R)/(1.D0+R)*P0N2-
     &    40.D0/(1.D0+R)/(1.D0+R)*P0N2**2-16.D0/(1.D0+R)/(1.D0+R)*P1N2-
     &    28.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+48.D0/(1.D0+R)/(1.D0+R)/(1.D0
     &    +R)*P0N2-20.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)/(1.D0+R)+17.D0/18.D0
     &    /(
     & 2.D0+R)+6.D0/(2.D0+R)*ZETA2*P0N3+7.D0/(2.D0+R)*ZETA2-4.D0/3.D0/(
     &    2.D0+R)*ZETA3-6.D0/(2.D0+R)*P0N3*P1N3-48.D0/(2.D0+R)*P0N3-45.D
     &  0/(2.D0+R)*P0N3**2-26.D0/3.D0/(2.D0+R)*P0N3**3-1/(2.D0+R)*P1N3+
     &    10.D0/3.D0/(2.D0+R)*P2N3-16.D0/(2.D0+R)*B1N3+214.D0/3.D0/(2.D0
     &    +R)/(2.D0+R)-4.D0/(2.D0+R)/(2.D0+R)*ZETA2+88.D0/(2.D0+R)/(2.D0
     &    +R)*P0N3+20.D0/(2.D0+R)/(2.D0+R)*P0N3**2+8.D0/(2.D0+R)/(2.D0+
     &    R)*P1N3-63.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)-24.D0/(2.D0+R)/(2.D0
     &    +R)/(2.D0+R)*P0N3+10.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)/(2.D0+R)+
     &    1304.D0/27.D0/(3.D0+R)+248.D0/9.D0/(3.D0+R)*P0N4-16.D0/3.D0/(
     &    3.D0+R)*P1N4-32.D0/3.D0/(3.D0+R)*B1N4-112.D0/9.D0/(3.D0+R)/(3.
     &  D0+R)+32.D0/3.D0/(3.D0+R)/(3.D0+R)*P0N4-80.D0/3.D0/(3.D0+R)/(3.D
     &  0+R)/(3.D0+R)

      Sqg2CaCf=
     & +GE*XL*(-128.D0*R**(-2)+144.D0*R**(-1)*P0N1+868.D0/3.D0*R**(-1)-
     &    736.D0/3.D0/(1.D0+R)-144.D0/(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0
     &    +R)-40.D0/3.D0/(2.D0+R)+72.D0/(2.D0+R)*P0N3-112.D0/(2.D0+R)/(
     &    2.D0+R)-32.D0/(3.D0+R))
      Sqg2CaCf=Sqg2CaCf+GE*XL**2*(-24.D0*R**(-1)+24.D0/(1.D0+R)-12.D0/(
     &    2.D0+R))
      Sqg2CaCf=Sqg2CaCf+GE*(-128.D0*R**(-3)+264.D0*R**(-2)*P0N1+692.D0/
     &    3.D0*R**(-2)-124.D0*R**(-1)*ZETA2-1568.D0/3.D0*R**(-1)*P0N1-
     &    140.D0*R**(-1)*P0N1**2-36.D0*R**(-1)*P1N1+32.D0*R**(-1)*B1N1-
     &    4342.D0/9.D0*R**(-1)+904.D0/3.D0/(1.D0+R)+124.D0/(1.D0+R)*
     &    ZETA2+1268.D0/3.D0/(1.D0+R)*P0N2+140.D0/(1.D0+R)*P0N2**2+36.D0
     &    /(1.D0+R)*P1N2+32.D0/(1.D0+R)*B1N2-832.D0/3.D0/(1.D0+R)/(1.D0
     &    +R)+120.D0/(1.D0+R)/(1.D0+R)*P0N2-96.D0/(1.D0+R)/(1.D0+R)/(1.D
     &  0+R)+116.D0/(2.D0+R)-62.D0/(2.D0+R)*ZETA2+194.D0/3.D0/(2.D0+R)*
     &    P0N3-70.D0/(2.D0+R)*P0N3**2-18.D0/(2.D0+R)*P1N3+16.D0/(2.D0+R
     &    )*B1N3-40.D0/3.D0/(2.D0+R)/(2.D0+R)+228.D0/(2.D0+R)/(2.D0+R)*
     &    P0N3-128.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)+64.D0/9.D0/(3.D0+R)+64.
     &  D0/(3.D0+R)*P0N4-64.D0/(3.D0+R)/(3.D0+R))
      Sqg2CaCf=Sqg2CaCf+GE**2*XL*(72.D0*R**(-1)-72.D0/(1.D0+R)+36.D0/(2.
     &  D0+R))
      Sqg2CaCf=Sqg2CaCf+GE**2*(132.D0*R**(-2)-140.D0*R**(-1)*P0N1-784.D0
     &  /3.D0*R**(-1)+634.D0/3.D0/(1.D0+R)+140.D0/(1.D0+R)*P0N2+60.D0/(
     &    1.D0+R)/(1.D0+R)+97.D0/3.D0/(2.D0+R)-70.D0/(2.D0+R)*P0N3+114.D
     &  0/(2.D0+R)/(2.D0+R)+32.D0/(3.D0+R))
      Sqg2CaCf=Sqg2CaCf+GE**3*(-140.D0/3.D0*R**(-1)+140.D0/3.D0/(1.D0+R
     &    )-70.D0/3.D0/(2.D0+R))
      Sqg2CaCf=Sqg2CaCf+XL*(48.D0*R**(-3)-128.D0*R**(-2)*P0N1-124.D0*
     &    R**(-2)+64.D0*R**(-1)*ZETA2+868.D0/3.D0*R**(-1)*P0N1+72.D0*
     &    R**(-1)*P0N1**2+8.D0*R**(-1)*P1N1-16.D0*R**(-1)*B1N1+2422.D0/
     &    9.D0*R**(-1)-1724.D0/9.D0/(1.D0+R)-64.D0/(1.D0+R)*ZETA2-736.D0
     &  /3.D0/(1.D0+R)*P0N2-72.D0/(1.D0+R)*P0N2**2-8.D0/(1.D0+R)*P1N2-
     &    16.D0/(1.D0+R)*B1N2+448.D0/3.D0/(1.D0+R)/(1.D0+R)-64.D0/(1.D0
     &    +R)/(1.D0+R)*P0N2+64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)-362.D0/9.D0
     &    /(2.D0+R)+32.D0/(2.D0+R)*ZETA2-40.D0/3.D0/(2.D0+R)*P0N3+36.D0
     &    /(2.D0+R)*P0N3**2+4.D0/(2.D0+R)*P1N3-8.D0/(2.D0+R)*B1N3-8.D0/
     &    3.D0/(2.D0+R)/(2.D0+R)-112.D0/(2.D0+R)/(2.D0+R)*P0N3+56.D0/(2.
     &  D0+R)/(2.D0+R)/(2.D0+R)-32.D0/9.D0/(3.D0+R)-32.D0/(3.D0+R)*P0N4
     &    +32.D0/(3.D0+R)/(3.D0+R))
      Sqg2CaCf=Sqg2CaCf+XL**2*(24.D0*R**(-2)-24.D0*R**(-1)*P0N1-230.D0/
     &    3.D0*R**(-1)+188.D0/3.D0/(1.D0+R)+24.D0/(1.D0+R)*P0N2+24.D0/(
     &    1.D0+R)/(1.D0+R)-4.D0/3.D0/(2.D0+R)-12.D0/(2.D0+R)*P0N3+24.D0
     &    /(2.D0+R)/(2.D0+R)+8.D0/(3.D0+R))
      Sqg2CaCf=Sqg2CaCf+ACG18(1.D0+R)*(8.D0/(1.D0+R))
      Sqg2CaCf=Sqg2CaCf+ACG18(2.D0+R)*(-4.D0/(2.D0+R))
      Sqg2CaCf=Sqg2CaCf+ACG18(R)*(-8.D0*R**(-1))
      Sqg2CaCf=Sqg2CaCf+48.D0*R**(-4)-128.D0*R**(-3)*P0N1-124.D0*
     &    R**(-3)+60.D0*R**(-2)*ZETA2+692.D0/3.D0*R**(-2)*P0N1+132.D0*
     &    R**(-2)*P0N1**2+44.D0*R**(-2)*P1N1-16.D0*R**(-2)*B1N1+2402.D0/
     &    9.D0*R**(-2)-124.D0*R**(-1)*ZETA2*P0N1-166.D0/3.D0*R**(-1)*
     &    ZETA2+92.D0/3.D0*R**(-1)*ZETA3-36.D0*R**(-1)*P0N1*P1N1+32.D0*
     &    R**(-1)*P0N1*B1N1-4342.D0/9.D0*R**(-1)*P0N1-784.D0/3.D0*
     &    R**(-1)*P0N1**2-140.D0/3.D0*R**(-1)*P0N1**3-446.D0/3.D0*
     &    R**(-1)*P1N1-8.D0/3.D0*R**(-1)*P2N1+88.D0/3.D0*R**(-1)*B1N1+8.
     &  D0*R**(-1)*B2N1-21539.D0/54.D0*R**(-1)+9962.D0/27.D0/(1.D0+R)+
     &    124.D0/(1.D0+R)*ZETA2*P0N2+310.D0/3.D0/(1.D0+R)*ZETA2-92.D0/3.
     &  D0/(1.D0+R)*ZETA3+36.D0/(1.D0+R)*P0N2*P1N2+32.D0/(1.D0+R)*P0N2*
     &    B1N2+904.D0/3.D0/(1.D0+R)*P0N2+634.D0/3.D0/(1.D0+R)*P0N2**2+
     &    140.D0/3.D0/(1.D0+R)*P0N2**3+106.D0/(1.D0+R)*P1N2+8.D0/3.D0/(
     &    1.D0+R)*P2N2+40.D0/(1.D0+R)*B1N2+8.D0/(1.D0+R)*B2N2-2660.D0/9.
     &  D0/(1.D0+R)/(1.D0+R)-60.D0/(1.D0+R)/(1.D0+R)*ZETA2-832.D0/3.D0
     &    /(
     & 1.D0+R)/(1.D0+R)*P0N2+60.D0/(1.D0+R)/(1.D0+R)*P0N2**2+68.D0/(1.D0
     &    +R)/(1.D0+R)*P1N2-16.D0/(1.D0+R)/(1.D0+R)*B1N2+688.D0/3.D0/(1.
     &  D0+R)/(1.D0+R)/(1.D0+R)-96.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)*P0N2+
     &    72.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)/(1.D0+R)+1171.D0/54.D0/(2.D0
     &    +R)-62.D0/(2.D0+R)*ZETA2*P0N3-59.D0/3.D0/(2.D0+R)*ZETA2+46.D0/
     &    3.D0/(2.D0+R)*ZETA3-18.D0/(2.D0+R)*P0N3*P1N3+16.D0/(2.D0+R)*
     &    P0N3*B1N3+116.D0/(2.D0+R)*P0N3+97.D0/3.D0/(2.D0+R)*P0N3**2-70.
     &  D0/3.D0/(2.D0+R)*P0N3**3+15.D0/(2.D0+R)*P1N3-4.D0/3.D0/(2.D0+R)
     &    *P2N3+12.D0/(2.D0+R)*B1N3+4.D0/(2.D0+R)*B2N3-1079.D0/9.D0/(2.D
     &  0+R)/(2.D0+R)+30.D0/(2.D0+R)/(2.D0+R)*ZETA2-40.D0/3.D0/(2.D0+R)
     &    /(2.D0+R)*P0N3+114.D0/(2.D0+R)/(2.D0+R)*P0N3**2+46.D0/(2.D0+R
     &    )/(2.D0+R)*P1N3-8.D0/(2.D0+R)/(2.D0+R)*B1N3-20.D0/3.D0/(2.D0+
     &    R)/(2.D0+R)/(2.D0+R)-128.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)*P0N3+
     &    60.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)/(2.D0+R)-238.D0/27.D0/(3.D0+
     &    R)+64.D0/9.D0/(3.D0+R)*P0N4+32.D0/(3.D0+R)*P0N4**2+56.D0/3.D0
     &    /(
     & 3.D0+R)*P1N4+16.D0/3.D0/(3.D0+R)*B1N4-224.D0/9.D0/(3.D0+R)/(3.D0
     &    +R)-64.D0/(3.D0+R)/(3.D0+R)*P0N4+136.D0/3.D0/(3.D0+R)/(3.D0+R
     &    )/(3.D0+R)

      Sqg2CfTfnf=
     & +GE*XL*(-32.D0/3.D0*R**(-1)+32.D0/3.D0/(1.D0+R)-16.D0/3.D0/(2.D0
     &    +R))
      Sqg2CfTfnf=Sqg2CfTfnf+GE*(-32.D0/3.D0*R**(-2)+16.D0/3.D0*R**(-1)*
     &    P0N1+104.D0/3.D0*R**(-1)-128.D0/3.D0/(1.D0+R)-16.D0/3.D0/(1.D0
     &    +R)*P0N2+32.D0/3.D0/(1.D0+R)/(1.D0+R)+24.D0/(2.D0+R)+8.D0/3.D0
     &    /(2.D0+R)*P0N3-16.D0/3.D0/(2.D0+R)/(2.D0+R))
      Sqg2CfTfnf=Sqg2CfTfnf+GE**2*(8.D0/3.D0*R**(-1)-8.D0/3.D0/(1.D0+R)
     &    +4.D0/3.D0/(2.D0+R))
      Sqg2CfTfnf=Sqg2CfTfnf+XL*(32.D0/3.D0*R**(-2)-32.D0/3.D0*R**(-1)*
     &    P0N1-232.D0/9.D0*R**(-1)+304.D0/9.D0/(1.D0+R)+32.D0/3.D0/(1.D0
     &    +R)*P0N2-32.D0/3.D0/(1.D0+R)/(1.D0+R)-152.D0/9.D0/(2.D0+R)-16.
     &  D0/3.D0/(2.D0+R)*P0N3+16.D0/3.D0/(2.D0+R)/(2.D0+R))
      Sqg2CfTfnf=Sqg2CfTfnf+XL**2*(16.D0/3.D0*R**(-1)-16.D0/3.D0/(1.D0+
     &    R)+8.D0/3.D0/(2.D0+R))
      Sqg2CfTfnf=Sqg2CfTfnf+32.D0/3.D0*R**(-3)-32.D0/3.D0*R**(-2)*P0N1-
     &    232.D0/9.D0*R**(-2)+8.D0/3.D0*R**(-1)*ZETA2+104.D0/3.D0*
     &    R**(-1)*P0N1+8.D0/3.D0*R**(-1)*P0N1**2+8.D0*R**(-1)*P1N1+1060.
     &  D0/27.D0*R**(-1)-1672.D0/27.D0/(1.D0+R)-8.D0/3.D0/(1.D0+R)*
     &    ZETA2-128.D0/3.D0/(1.D0+R)*P0N2-8.D0/3.D0/(1.D0+R)*P0N2**2-8.D
     &  0/(1.D0+R)*P1N2+304.D0/9.D0/(1.D0+R)/(1.D0+R)+32.D0/3.D0/(1.D0+
     &    R)/(1.D0+R)*P0N2-32.D0/3.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+716.D0/
     &    27.D0/(2.D0+R)+4.D0/3.D0/(2.D0+R)*ZETA2+24.D0/(2.D0+R)*P0N3+4.
     &  D0/3.D0/(2.D0+R)*P0N3**2+4.D0/(2.D0+R)*P1N3-152.D0/9.D0/(2.D0+R
     &    )/(2.D0+R)-16.D0/3.D0/(2.D0+R)/(2.D0+R)*P0N3+16.D0/3.D0/(2.D0
     &    +R)/(2.D0+R)/(2.D0+R)

      Sqg2rest=
     & +GE*CF*CG1*(-16.D0*R**(-1)+16.D0/(1.D0+R)-8.D0/(2.D0+R))
      Sqg2rest=Sqg2rest+CF*XL*CG1*(8.D0*R**(-1)-8.D0/(1.D0+R)+4.D0/(2.D0
     &    +R))
      Sqg2rest=Sqg2rest+CF*CG1*(8.D0*R**(-2)-16.D0*R**(-1)*P0N1-6.D0*
     &    R**(-1)+12.D0/(1.D0+R)+16.D0/(1.D0+R)*P0N2-8.D0/(1.D0+R)/(1.D0
     &    +R)-2.D0/(2.D0+R)-8.D0/(2.D0+R)*P0N3+4.D0/(2.D0+R)/(2.D0+R))

      SqqCaCf2=
     & +8.D0*R**(-1)*P2N1-10.D0*R**(-1)-32.D0/(1.D0+R)-8.D0/(1.D0+R)*
     &    P2N2+16.D0/(1.D0+R)/(1.D0+R)+16.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)
     &    +42.D0/(2.D0+R)+4.D0/(2.D0+R)*P2N3+36.D0/(2.D0+R)/(2.D0+R)+24.
     &  D0/(2.D0+R)/(2.D0+R)/(2.D0+R)

      SqqCf3=
     & -16.D0*R**(-1)*P2N1+20.D0*R**(-1)+64.D0/(1.D0+R)+16.D0/(1.D0+R)*
     &    P2N2-32.D0/(1.D0+R)/(1.D0+R)-32.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)
     &    -84.D0/(2.D0+R)-8.D0/(2.D0+R)*P2N3-72.D0/(2.D0+R)/(2.D0+R)-48.
     &  D0/(2.D0+R)/(2.D0+R)/(2.D0+R)

      SqqCf2=
     & +GE*XL*(-64.D0*R**(-2)+96.D0*R**(-1)-64.D0/(1.D0+R)-64.D0/(1.D0+
     &    R)/(1.D0+R)-32.D0/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R))
      SqqCf2=SqqCf2+GE*(-64.D0*R**(-3)+128.D0*R**(-2)*P0N1+96.D0*
     &    R**(-2)-192.D0*R**(-1)*P0N1-204.D0*R**(-1)+144.D0/(1.D0+R)+
     &    128.D0/(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)+128.D0/(1.D0+R)
     &    /(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+60.D0/(2.D0+R
     &    )+64.D0/(2.D0+R)*P0N3-40.D0/(2.D0+R)/(2.D0+R)+32.D0/(2.D0+R)
     &    /(2.D0+R)*P0N3-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      SqqCf2=SqqCf2+GE**2*(64.D0*R**(-2)-96.D0*R**(-1)+64.D0/(1.D0+R)+
     &    64.D0/(1.D0+R)/(1.D0+R)+32.D0/(2.D0+R)+16.D0/(2.D0+R)/(2.D0+R
     &    ))
      SqqCf2=SqqCf2+XL*(32.D0*R**(-3)-64.D0*R**(-2)*P0N1-48.D0*R**(-2)+
     &    96.D0*R**(-1)*P0N1+102.D0*R**(-1)-72.D0/(1.D0+R)-64.D0/(1.D0+
     &    R)*P0N2+32.D0/(1.D0+R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)*P0N2+
     &    32.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)-30.D0/(2.D0+R)-32.D0/(2.D0+R
     &    )*P0N3+20.D0/(2.D0+R)/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R)*P0N3+8.
     &  D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      SqqCf2=SqqCf2+XL**2*(16.D0*R**(-2)-24.D0*R**(-1)+16.D0/(1.D0+R)+
     &    16.D0/(1.D0+R)/(1.D0+R)+8.D0/(2.D0+R)+4.D0/(2.D0+R)/(2.D0+R))
      SqqCf2=SqqCf2+32.D0*R**(-4)-64.D0*R**(-3)*P0N1-48.D0*R**(-3)+96.D0
     &    *R**(-2)*P0N1+64.D0*R**(-2)*P0N1**2+32.D0*R**(-2)*P1N1+118.D0
     &    *R**(-2)-204.D0*R**(-1)*P0N1-96.D0*R**(-1)*P0N1**2-48.D0*
     &    R**(-1)*P1N1-210.D0*R**(-1)+188.D0/(1.D0+R)+144.D0/(1.D0+R)*
     &    P0N2+64.D0/(1.D0+R)*P0N2**2+32.D0/(1.D0+R)*P1N2-88.D0/(1.D0+R
     &    )/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)*P0N2+64.D0/(1.D0+R)/(1.D0+
     &    R)*P0N2**2+32.D0/(1.D0+R)/(1.D0+R)*P1N2+64.D0/(1.D0+R)/(1.D0+
     &    R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)*P0N2+32.D0/(1.D0
     &    +R)/(1.D0+R)/(1.D0+R)/(1.D0+R)+22.D0/(2.D0+R)+60.D0/(2.D0+R)*
     &    P0N3+32.D0/(2.D0+R)*P0N3**2+16.D0/(2.D0+R)*P1N3-58.D0/(2.D0+R
     &    )/(2.D0+R)-40.D0/(2.D0+R)/(2.D0+R)*P0N3+16.D0/(2.D0+R)/(2.D0+
     &    R)*P0N3**2+8.D0/(2.D0+R)/(2.D0+R)*P1N3+16.D0/(2.D0+R)/(2.D0+R
     &    )/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)*P0N3+8.D0/(2.D0+R
     &    )/(2.D0+R)/(2.D0+R)/(2.D0+R)

      Sqqrest=0

      SqqbCaCf2=
     & +GE*(64.D0/3.D0*R**(-1)*P0N1-32.D0*R**(-1)*B1N1+128.D0/3.D0*
     &    R**(-1)-128.D0/(1.D0+R)-64.D0/(1.D0+R)*P0N2-32.D0/(1.D0+R)*
     &    B1N2+128.D0/(2.D0+R)+64.D0/(2.D0+R)*P0N3-16.D0/(2.D0+R)*B1N3-
     &    128.D0/3.D0/(3.D0+R)-64.D0/3.D0/(3.D0+R)*P0N4)
      SqqbCaCf2=SqqbCaCf2+GE**2*(32.D0/3.D0*R**(-1)-32.D0/(1.D0+R)+32.D0
     &    /(2.D0+R)-32.D0/3.D0/(3.D0+R))
      SqqbCaCf2=SqqbCaCf2+XL*(-88.D0/3.D0*R**(-1)+88.D0/(1.D0+R)-88.D0
     &    /(2.D0+R)+88.D0/3.D0/(3.D0+R))
      SqqbCaCf2=SqqbCaCf2+ACG3(1.D0+R)*(32.D0/(1.D0+R))
      SqqbCaCf2=SqqbCaCf2+ACG3(2.D0+R)*(16.D0/(2.D0+R))
      SqqbCaCf2=SqqbCaCf2+ACG3(R)*(32.D0*R**(-1))
      SqqbCaCf2=SqqbCaCf2-88.D0/3.D0*R**(-2)-32.D0*R**(-1)*ZETA2*BN1-48.
     &  D0*R**(-1)*ZETA2-32.D0*R**(-1)*P0N1*B1N1+128.D0/3.D0*R**(-1)*
     &    P0N1+32.D0/3.D0*R**(-1)*P0N1**2+16.D0*R**(-1)*P1N1-8.D0*
     &    R**(-1)*B2N1+130.D0*R**(-1)-316.D0/(1.D0+R)-32.D0/(1.D0+R)*
     &    ZETA2*BN2+144.D0/(1.D0+R)*ZETA2-32.D0/(1.D0+R)*P0N2*B1N2-128.D
     &  0/(1.D0+R)*P0N2-32.D0/(1.D0+R)*P0N2**2-48.D0/(1.D0+R)*P1N2-32.D0
     &    /(1.D0+R)*B1N2-8.D0/(1.D0+R)*B2N2+296.D0/3.D0/(1.D0+R)/(1.D0+
     &    R)-80.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+890.D0/3.D0/(2.D0+R)-16.D0
     &    /(2.D0+R)*ZETA2*BN3-144.D0/(2.D0+R)*ZETA2-16.D0/(2.D0+R)*P0N3
     &    *B1N3+128.D0/(2.D0+R)*P0N3+32.D0/(2.D0+R)*P0N3**2+48.D0/(2.D0
     &    +R)*P1N3-16.D0/(2.D0+R)*B1N3-4.D0/(2.D0+R)*B2N3-500.D0/3.D0/(
     &    2.D0+R)/(2.D0+R)-332.D0/3.D0/(3.D0+R)+48.D0/(3.D0+R)*ZETA2-
     &    128.D0/3.D0/(3.D0+R)*P0N4-32.D0/3.D0/(3.D0+R)*P0N4**2-16.D0/(
     &    3.D0+R)*P1N4-32.D0/3.D0/(3.D0+R)*B1N4+128.D0/3.D0/(3.D0+R)/(3.
     &  D0+R)-64.D0/3.D0/(3.D0+R)/(3.D0+R)/(3.D0+R)

      SqqbCf3=
     & +GE*XL*(-64.D0/3.D0*R**(-1)+64.D0/(1.D0+R)-64.D0/(2.D0+R)+64.D0/
     &    3.D0/(3.D0+R))
      SqqbCf3=SqqbCf3+GE*(-64.D0/3.D0*R**(-2)+64.D0/3.D0*R**(-1)*P0N1+
     &    64.D0*R**(-1)*B1N1+32.D0*R**(-1)-352.D0/3.D0/(1.D0+R)-64.D0/(
     &    1.D0+R)*P0N2+64.D0/(1.D0+R)*B1N2+96.D0/(1.D0+R)/(1.D0+R)+352.D
     &  0/3.D0/(2.D0+R)+64.D0/(2.D0+R)*P0N3+32.D0/(2.D0+R)*B1N3-96.D0/(
     &    2.D0+R)/(2.D0+R)-32.D0/(3.D0+R)-64.D0/3.D0/(3.D0+R)*P0N4+128.D
     &  0/3.D0/(3.D0+R)/(3.D0+R))
      SqqbCf3=SqqbCf3+GE**2*(32.D0/3.D0*R**(-1)-32.D0/(1.D0+R)+32.D0/(2.
     &  D0+R)-32.D0/3.D0/(3.D0+R))
      SqqbCf3=SqqbCf3+XL*(-64.D0/3.D0*R**(-1)*P0N1+64.D0/3.D0/(1.D0+R)+
     &    64.D0/(1.D0+R)*P0N2-32.D0/(1.D0+R)/(1.D0+R)-64.D0/3.D0/(2.D0+
     &    R)-64.D0/(2.D0+R)*P0N3+32.D0/(2.D0+R)/(2.D0+R)+64.D0/3.D0/(3.D
     &  0+R)*P0N4-64.D0/3.D0/(3.D0+R)/(3.D0+R))
      SqqbCf3=SqqbCf3+ACG3(1.D0+R)*(-64.D0/(1.D0+R))
      SqqbCf3=SqqbCf3+ACG3(2.D0+R)*(-32.D0/(2.D0+R))
      SqqbCf3=SqqbCf3+ACG3(R)*(-64.D0*R**(-1))
      SqqbCf3=SqqbCf3-64.D0/3.D0*R**(-2)*P0N1+64.D0*R**(-1)*ZETA2*BN1+
     &    256.D0/3.D0*R**(-1)*ZETA2+64.D0*R**(-1)*P0N1*B1N1+32.D0*
     &    R**(-1)*P0N1+32.D0/3.D0*R**(-1)*P0N1**2-64.D0/3.D0*R**(-1)*
     &    P1N1+16.D0*R**(-1)*B2N1-164.D0/3.D0*R**(-1)-64.D0/(1.D0+R)+64.
     &  D0/(1.D0+R)*ZETA2*BN2-256.D0/(1.D0+R)*ZETA2+64.D0/(1.D0+R)*P0N2
     &    *B1N2-352.D0/3.D0/(1.D0+R)*P0N2-32.D0/(1.D0+R)*P0N2**2+64.D0
     &    /(1.D0+R)*P1N2+64.D0/(1.D0+R)*B1N2+16.D0/(1.D0+R)*B2N2+256.D0/
     &    3.D0/(1.D0+R)/(1.D0+R)+96.D0/(1.D0+R)/(1.D0+R)*P0N2+80.D0/(1.D
     &  0+R)/(1.D0+R)/(1.D0+R)+260.D0/3.D0/(2.D0+R)+32.D0/(2.D0+R)*
     &    ZETA2*BN3+256.D0/(2.D0+R)*ZETA2+32.D0/(2.D0+R)*P0N3*B1N3+352.D
     &  0/3.D0/(2.D0+R)*P0N3+32.D0/(2.D0+R)*P0N3**2-64.D0/(2.D0+R)*P1N3
     &    +32.D0/(2.D0+R)*B1N3+8.D0/(2.D0+R)*B2N3+200.D0/3.D0/(2.D0+R)
     &    /(2.D0+R)-96.D0/(2.D0+R)/(2.D0+R)*P0N3+96.D0/(2.D0+R)/(2.D0+R
     &    )/(2.D0+R)+32.D0/(3.D0+R)-256.D0/3.D0/(3.D0+R)*ZETA2-32.D0/(3.
     &  D0+R)*P0N4-32.D0/3.D0/(3.D0+R)*P0N4**2+64.D0/3.D0/(3.D0+R)*P1N4
     &    +32.D0/(
     & 3.D0+R)/(3.D0+R)+128.D0/3.D0/(3.D0+R)/(3.D0+R)*P0N4-32.D0/3.D0/(
     &    3.D0+R)/(3.D0+R)/(3.D0+R)

      SqqbCf2=
     & +GE*XL*(-64.D0*R**(-2)+96.D0*R**(-1)-64.D0/(1.D0+R)-64.D0/(1.D0+
     &    R)/(1.D0+R)-32.D0/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R))
      SqqbCf2=SqqbCf2+GE*(-64.D0*R**(-3)+128.D0*R**(-2)*P0N1+96.D0*
     &    R**(-2)-192.D0*R**(-1)*P0N1-204.D0*R**(-1)+144.D0/(1.D0+R)+
     &    128.D0/(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)+128.D0/(1.D0+R)
     &    /(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+60.D0/(2.D0+R
     &    )+64.D0/(2.D0+R)*P0N3-40.D0/(2.D0+R)/(2.D0+R)+32.D0/(2.D0+R)
     &    /(2.D0+R)*P0N3-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      SqqbCf2=SqqbCf2+GE**2*(64.D0*R**(-2)-96.D0*R**(-1)+64.D0/(1.D0+R)
     &    +64.D0/(1.D0+R)/(1.D0+R)+32.D0/(2.D0+R)+16.D0/(2.D0+R)/(2.D0+
     &    R))
      SqqbCf2=SqqbCf2+XL*(32.D0*R**(-3)-64.D0*R**(-2)*P0N1-48.D0*
     &    R**(-2)+96.D0*R**(-1)*P0N1+102.D0*R**(-1)-72.D0/(1.D0+R)-64.D0
     &    /(1.D0+R)*P0N2+32.D0/(1.D0+R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R
     &    )*P0N2+32.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)-30.D0/(2.D0+R)-32.D0
     &    /(2.D0+R)*P0N3+20.D0/(2.D0+R)/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R
     &    )*P0N3+8.D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      SqqbCf2=SqqbCf2+XL**2*(16.D0*R**(-2)-24.D0*R**(-1)+16.D0/(1.D0+R)
     &    +16.D0/(1.D0+R)/(1.D0+R)+8.D0/(2.D0+R)+4.D0/(2.D0+R)/(2.D0+R)
     &    )
      SqqbCf2=SqqbCf2+32.D0*R**(-4)-64.D0*R**(-3)*P0N1-48.D0*R**(-3)+96.
     &  D0*R**(-2)*P0N1+64.D0*R**(-2)*P0N1**2+32.D0*R**(-2)*P1N1+118.D0
     &    *R**(-2)-204.D0*R**(-1)*P0N1-96.D0*R**(-1)*P0N1**2-48.D0*
     &    R**(-1)*P1N1-210.D0*R**(-1)+188.D0/(1.D0+R)+144.D0/(1.D0+R)*
     &    P0N2+64.D0/(1.D0+R)*P0N2**2+32.D0/(1.D0+R)*P1N2-88.D0/(1.D0+R
     &    )/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)*P0N2+64.D0/(1.D0+R)/(1.D0+
     &    R)*P0N2**2+32.D0/(1.D0+R)/(1.D0+R)*P1N2+64.D0/(1.D0+R)/(1.D0+
     &    R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)*P0N2+32.D0/(1.D0
     &    +R)/(1.D0+R)/(1.D0+R)/(1.D0+R)+22.D0/(2.D0+R)+60.D0/(2.D0+R)*
     &    P0N3+32.D0/(2.D0+R)*P0N3**2+16.D0/(2.D0+R)*P1N3-58.D0/(2.D0+R
     &    )/(2.D0+R)-40.D0/(2.D0+R)/(2.D0+R)*P0N3+16.D0/(2.D0+R)/(2.D0+
     &    R)*P0N3**2+8.D0/(2.D0+R)/(2.D0+R)*P1N3+16.D0/(2.D0+R)/(2.D0+R
     &    )/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)*P0N3+8.D0/(2.D0+R
     &    )/(2.D0+R)/(2.D0+R)/(2.D0+R)

      SqqbCf2Tfnf=
     & +GE*(-64.D0/9.D0*R**(-1)+64.D0/3.D0/(1.D0+R)-64.D0/3.D0/(2.D0+R)
     &    +64.D0/9.D0/(3.D0+R))
      SqqbCf2Tfnf=SqqbCf2Tfnf+XL*(32.D0/3.D0*R**(-1)-32.D0/(1.D0+R)+32.D
     &  0/(2.D0+R)-32.D0/3.D0/(3.D0+R))
      SqqbCf2Tfnf=SqqbCf2Tfnf+32.D0/3.D0*R**(-2)-64.D0/9.D0*R**(-1)*
     &    P0N1-368.D0/27.D0*R**(-1)+592.D0/9.D0/(1.D0+R)+64.D0/3.D0/(1.D
     &  0+R)*P0N2-160.D0/3.D0/(1.D0+R)/(1.D0+R)-688.D0/9.D0/(2.D0+R)-64.
     &  D0/3.D0/(2.D0+R)*P0N3+128.D0/3.D0/(2.D0+R)/(2.D0+R)+656.D0/27.D0
     &    /(3.D0+R)+64.D0/9.D0/(3.D0+R)*P0N4-128.D0/9.D0/(3.D0+R)/(3.D0
     &    +R)

      Sqqbrest=
     & +CF**2*CG1*(16.D0/3.D0*R**(-1)-16.D0/(1.D0+R)+16.D0/(2.D0+R)-16.D
     &  0/3.D0/(3.D0+R))

      Sq1qb2Cf2=
     & +GE*XL*(-64.D0*R**(-2)+96.D0*R**(-1)-64.D0/(1.D0+R)-64.D0/(1.D0+
     &    R)/(1.D0+R)-32.D0/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R))
      Sq1qb2Cf2=Sq1qb2Cf2+GE*(-64.D0*R**(-3)+128.D0*R**(-2)*P0N1+96.D0*
     &    R**(-2)-192.D0*R**(-1)*P0N1-204.D0*R**(-1)+144.D0/(1.D0+R)+
     &    128.D0/(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)+128.D0/(1.D0+R)
     &    /(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+60.D0/(2.D0+R
     &    )+64.D0/(2.D0+R)*P0N3-40.D0/(2.D0+R)/(2.D0+R)+32.D0/(2.D0+R)
     &    /(2.D0+R)*P0N3-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      Sq1qb2Cf2=Sq1qb2Cf2+GE**2*(64.D0*R**(-2)-96.D0*R**(-1)+64.D0/(1.D0
     &    +R)+64.D0/(1.D0+R)/(1.D0+R)+32.D0/(2.D0+R)+16.D0/(2.D0+R)/(2.D
     &  0+R))
      Sq1qb2Cf2=Sq1qb2Cf2+XL*(32.D0*R**(-3)-64.D0*R**(-2)*P0N1-48.D0*
     &    R**(-2)+96.D0*R**(-1)*P0N1+102.D0*R**(-1)-72.D0/(1.D0+R)-64.D0
     &    /(1.D0+R)*P0N2+32.D0/(1.D0+R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R
     &    )*P0N2+32.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)-30.D0/(2.D0+R)-32.D0
     &    /(2.D0+R)*P0N3+20.D0/(2.D0+R)/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R
     &    )*P0N3+8.D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      Sq1qb2Cf2=Sq1qb2Cf2+XL**2*(16.D0*R**(-2)-24.D0*R**(-1)+16.D0/(1.D0
     &    +R)+16.D0/(1.D0+R)/(1.D0+R)+8.D0/(2.D0+R)+4.D0/(2.D0+R)/(2.D0
     &    +R))
      Sq1qb2Cf2=Sq1qb2Cf2+32.D0*R**(-4)-64.D0*R**(-3)*P0N1-48.D0*
     &    R**(-3)+96.D0*R**(-2)*P0N1+64.D0*R**(-2)*P0N1**2+32.D0*
     &    R**(-2)*P1N1+118.D0*R**(-2)-204.D0*R**(-1)*P0N1-96.D0*R**(-1)
     &    *P0N1**2-48.D0*R**(-1)*P1N1-210.D0*R**(-1)+188.D0/(1.D0+R)+
     &    144.D0/(1.D0+R)*P0N2+64.D0/(1.D0+R)*P0N2**2+32.D0/(1.D0+R)*
     &    P1N2-88.D0/(1.D0+R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)*P0N2+64.D
     &  0/(1.D0+R)/(1.D0+R)*P0N2**2+32.D0/(1.D0+R)/(1.D0+R)*P1N2+64.D0
     &    /(1.D0+R)/(1.D0+R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)*
     &    P0N2+32.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)/(1.D0+R)+22.D0/(2.D0+R)
     &    +60.D0/(2.D0+R)*P0N3+32.D0/(2.D0+R)*P0N3**2+16.D0/(2.D0+R)*
     &    P1N3-58.D0/(2.D0+R)/(2.D0+R)-40.D0/(2.D0+R)/(2.D0+R)*P0N3+16.D
     &  0/(2.D0+R)/(2.D0+R)*P0N3**2+8.D0/(2.D0+R)/(2.D0+R)*P1N3+16.D0/(
     &    2.D0+R)/(2.D0+R)/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)*
     &    P0N3+8.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)/(2.D0+R)

      Sq1qb2rest=0

      Sq1q2Cf2=
     & +GE*XL*(-64.D0*R**(-2)+96.D0*R**(-1)-64.D0/(1.D0+R)-64.D0/(1.D0+
     &    R)/(1.D0+R)-32.D0/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R))
      Sq1q2Cf2=Sq1q2Cf2+GE*(-64.D0*R**(-3)+128.D0*R**(-2)*P0N1+96.D0*
     &    R**(-2)-192.D0*R**(-1)*P0N1-204.D0*R**(-1)+144.D0/(1.D0+R)+
     &    128.D0/(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)+128.D0/(1.D0+R)
     &    /(1.D0+R)*P0N2-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)+60.D0/(2.D0+R
     &    )+64.D0/(2.D0+R)*P0N3-40.D0/(2.D0+R)/(2.D0+R)+32.D0/(2.D0+R)
     &    /(2.D0+R)*P0N3-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      Sq1q2Cf2=Sq1q2Cf2+GE**2*(64.D0*R**(-2)-96.D0*R**(-1)+64.D0/(1.D0+
     &    R)+64.D0/(1.D0+R)/(1.D0+R)+32.D0/(2.D0+R)+16.D0/(2.D0+R)/(2.D0
     &    +R))
      Sq1q2Cf2=Sq1q2Cf2+XL*(32.D0*R**(-3)-64.D0*R**(-2)*P0N1-48.D0*
     &    R**(-2)+96.D0*R**(-1)*P0N1+102.D0*R**(-1)-72.D0/(1.D0+R)-64.D0
     &    /(1.D0+R)*P0N2+32.D0/(1.D0+R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R
     &    )*P0N2+32.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)-30.D0/(2.D0+R)-32.D0
     &    /(2.D0+R)*P0N3+20.D0/(2.D0+R)/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R
     &    )*P0N3+8.D0/(2.D0+R)/(2.D0+R)/(2.D0+R))
      Sq1q2Cf2=Sq1q2Cf2+XL**2*(16.D0*R**(-2)-24.D0*R**(-1)+16.D0/(1.D0+
     &    R)+16.D0/(1.D0+R)/(1.D0+R)+8.D0/(2.D0+R)+4.D0/(2.D0+R)/(2.D0+
     &    R))
      Sq1q2Cf2=Sq1q2Cf2+32.D0*R**(-4)-64.D0*R**(-3)*P0N1-48.D0*R**(-3)+
     &    96.D0*R**(-2)*P0N1+64.D0*R**(-2)*P0N1**2+32.D0*R**(-2)*P1N1+
     &    118.D0*R**(-2)-204.D0*R**(-1)*P0N1-96.D0*R**(-1)*P0N1**2-48.D0
     &    *R**(-1)*P1N1-210.D0*R**(-1)+188.D0/(1.D0+R)+144.D0/(1.D0+R)*
     &    P0N2+64.D0/(1.D0+R)*P0N2**2+32.D0/(1.D0+R)*P1N2-88.D0/(1.D0+R
     &    )/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)*P0N2+64.D0/(1.D0+R)/(1.D0+
     &    R)*P0N2**2+32.D0/(1.D0+R)/(1.D0+R)*P1N2+64.D0/(1.D0+R)/(1.D0+
     &    R)/(1.D0+R)-64.D0/(1.D0+R)/(1.D0+R)/(1.D0+R)*P0N2+32.D0/(1.D0
     &    +R)/(1.D0+R)/(1.D0+R)/(1.D0+R)+22.D0/(2.D0+R)+60.D0/(2.D0+R)*
     &    P0N3+32.D0/(2.D0+R)*P0N3**2+16.D0/(2.D0+R)*P1N3-58.D0/(2.D0+R
     &    )/(2.D0+R)-40.D0/(2.D0+R)/(2.D0+R)*P0N3+16.D0/(2.D0+R)/(2.D0+
     &    R)*P0N3**2+8.D0/(2.D0+R)/(2.D0+R)*P1N3+16.D0/(2.D0+R)/(2.D0+R
     &    )/(2.D0+R)-16.D0/(2.D0+R)/(2.D0+R)/(2.D0+R)*P0N3+8.D0/(2.D0+R
     &    )/(2.D0+R)/(2.D0+R)/(2.D0+R)

      Sq1q2rest=0
      RETURN
      END

C THE ONE-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS1(RS,LAMBDA,NF)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,LAMBD2,NF
      PI=3.14159265359D0
      LAMBD2=LAMBDA*LAMBDA
      BF=(33.0D0-2.0D0*NF)/12.0D0/PI
      RS2=RS*RS
      DL1=DLOG(RS2/LAMBD2)
      ALFAS1=1.0D0/DL1/BF
      RETURN
      END
C THE TWO-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS2(RS,LAMBDA,NF)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,LAMBD2,NF
      PI=3.14159265359D0
      LAMBD2=LAMBDA*LAMBDA
      BF=(33.0D0-2.0D0*NF)/12.0D0/PI
      BFP=(153.0D0-19.0D0*NF)/(66.0D0-4.0D0*NF)/PI
      RS2=RS*RS
      DL1=DLOG(RS2/LAMBD2)
      DL2=DLOG(DL1)
      ALFAS2=(1.0D0-(BFP*DL2)/(BF*DL1))/DL1/BF
      RETURN
      END

C THE THREE-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS3(RS,LAMBDA,NFL)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,NFL
      PI=3.14159265359D0
      AL=2.0D0*DLOG(RS/LAMBDA)
      AL2=AL*AL
      AL3=AL2*AL
      BETA0=(11-2.0D0*NFL/3.0D0)/4.0D0
      BETA02=BETA0*BETA0
      BETA03=BETA02*BETA0
      B1=(102.0D0-38.0D0*NFL/3.0D0)/BETA0/16.0D0
      B2=(2857.0D0/2.0D0-5033.0D0*NFL/18.0D0
     1+325.0D0*NFL*NFL/54.0D0)/BETA0/64.0D0
      ALFAS3=PI*(1.0D0/BETA0/AL-B1*DLOG(AL)/BETA02/AL2
     2+(B1*B1*(DLOG(AL)**2.0D0-DLOG(AL)-1.0D0)+B2)
     3/BETA03/AL3)
      RETURN
      END
