       REAL*8 FUNCTION HQQB0(X)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL REQQB0
       EPS=1.0D-6
       KEY=2
       MAX=10000
       XLOW=0.0D0
       U=1.0D0
C
       HQQB0=(REQQB0(X))
C
       RETURN
       END

       REAL*8 FUNCTION HQQB1(X)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL REQQB1,PLUS1,PHIQQB,CQQB1PLUS,CQQB1DEL
       XLOW=0.0D0
       U=1.0D0
       R1=DAIND(X,U,REQQB1,EPS,KEY,MAX,KOU,EST)
       PLUSA=DAIND(X,U,PLUS1,EPS,KEY,MAX,KOU,EST)
       PLUSB=DAIND(XLOW,X,CQQB1PLUS,EPS,KEY,MAX,KOU,EST)
       P1=PLUSA-PLUSB*PHIQQB(X)
C
       HQQB1=(R1+P1+CQQB1DEL(X)*PHIQQB(X))
C
       RETURN
       END

       REAL*8 FUNCTION HQQB2(X)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL REQQB2,PLUS2,PHIQQB,CQQB2PLUS,CQQB2DEL
       XLOW=0.0D0
       U=1.0D0
       R2=DAIND(X,U,REQQB2,EPS,KEY,MAX,KOU,EST)
       PLUSA=DAIND(X,U,PLUS2,EPS,KEY,MAX,KOU,EST)
       PLUSB=DAIND(XLOW,X,CQQB2PLUS,EPS,KEY,MAX,KOU,EST)
       P2=PLUSA-PLUSB*PHIQQB(X)
C
       HQQB2=(R2+P2+CQQB2DEL(X)*PHIQQB(X))
C
       RETURN
       END

       REAL*8 FUNCTION HQQ2(X)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL REQQ2
       XLOW=0.0D0
       U=1.0D0
       R2=DAIND(X,U,REQQ2,EPS,KEY,MAX,KOU,EST)
C
       HQQ2=R2
C
       RETURN
       END

       REAL*8 FUNCTION HQG1(X)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL REQG1
       XLOW=0.0D0
       U=1.0D0
       R1=DAIND(X,U,REQG1,EPS,KEY,MAX,KOU,EST)
C
       HQG1=(R1)
C
       RETURN
       END

       REAL*8 FUNCTION HQG2(X)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL REQG2
       XLOW=0.0D0
       U=1.0D0
       R1=DAIND(X,U,REQG2,EPS,KEY,MAX,KOU,EST)
C
       HQG2=(R1)
C
       RETURN
       END

       REAL*8 FUNCTION HGG2(X)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL REGG2
       XLOW=0.0D0
       U=1.0D0
       R1=DAIND(X,U,REGG2,EPS,KEY,MAX,KOU,EST)
C
       HGG2=(R1)
C
       RETURN
       END

       REAL*8 FUNCTION PLUS1(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQQB,CQQB1PLUS

       XXBY=XX/Y

       DIFF=(PHIQQB(XXBY)/Y-PHIQQB(XX))
       PLUS1=CQQB1PLUS(Y)*DIFF
C
       RETURN
       END

       REAL*8 FUNCTION PLUS2(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQQB,CQQB2PLUS

       XXBY=XX/Y

       DIFF=(PHIQQB(XXBY)/Y-PHIQQB(XX))
       PLUS2=CQQB2PLUS(Y)*DIFF
C
       RETURN
       END

       REAL*8 FUNCTION REQQB0(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQQB,CQQB0

       REQQB0 =PHIQQB(Y)*CQQB0(Y)
C
       RETURN
       END


       REAL*8 FUNCTION REQQB1(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQQB,CQQB1R

       XXBY=XX/Y

       DIFF=(PHIQQB(XXBY))
       REQQB1 =CQQB1R(Y)/Y*DIFF
C
       RETURN
       END

       REAL*8 FUNCTION REQG1(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQG,CQG1

       XXBY=XX/Y

       DIFF=(PHIQG(XXBY))
       REQG1 =CQG1(Y)/Y*DIFF
C
       RETURN
       END

       REAL*8 FUNCTION REQG2(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQG,CQG2
 
       XXBY=XX/Y

       DIFF=(PHIQG(XXBY))
       REQG2 =CQG2(Y)/Y*DIFF
C
       RETURN
       END

       REAL*8 FUNCTION REGG2(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIGG,CGG2

       XXBY=XX/Y

       DIFF=(PHIGG(XXBY))
       REGG2 =CGG2(Y)/Y*DIFF

       RETURN
       END

       REAL*8 FUNCTION REQQB2(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQQB,PHIBBB,PHICCB,PHIDDB,PHICDB
       EXTERNAL CQQB2R,CQQBAC,CQQBBC,CQ1Q2CC,CQ1Q2CD,CQQBBB

       XXBY=XX/Y
       REQQB2 = PHIQQB(XXBY)*(CQQB2R(Y)+2.0D0*CQQBAC(Y)
     &  +2.0D0*CQQBBC(Y)+2.0D0*CQ1Q2CC(Y)+2.0D0*CQ1Q2CD(Y))
     &  +PHIBBB(XXBY)*CQQBBB(Y)
     &  +PHICCB(XXBY)*CQ1Q2CC(Y)
     &  +PHIDDB(XXBY)*CQ1Q2CC(Y)
     &  -PHICDB(XXBY)*CQ1Q2CD(Y)

       REQQB2 = REQQB2/Y
C
       RETURN
       END

       REAL*8 FUNCTION REQQ2(Y)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR/ XX
       EXTERNAL PHIQQ,PHICC,PHIDD,PHICD
       EXTERNAL CQ1Q2CC,CQ1Q2CD,CQQCE,CQQCF

       XXBY=XX/Y
       REQQ2 = PHICC(XXBY)*CQ1Q2CC(Y) +PHIDD(XXBY)*CQ1Q2CC(Y) 
     &  -PHICD(XXBY)*CQ1Q2CD(Y)
     &  +1.0D0/2.0D0*PHIQQ(XXBY)*(CQ1Q2CC(Y)+CQ1Q2CC(Y)
     &  -CQ1Q2CD(Y)+CQ1Q2CC(Y)+CQ1Q2CC(Y)-CQ1Q2CD(Y))
     &  +PHIQQ(XXBY)*(CQQCE(Y)+CQQCF(Y)+CQQCF(Y)+CQQCE(Y))

       REQQ2 = REQQ2/Y
C
       RETURN
       END

       REAL*8 FUNCTION PHIGG(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PGG
       U=1.0D0
       ZZ=Z
       PHIGG=DAIND(ZZ,U,PGG,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END

       REAL*8 FUNCTION PHIQG(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PQG
       U=1.0D0
       ZZ=Z
       PHIQG=DAIND(ZZ,U,PQG,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END


       REAL*8 FUNCTION PHIQQB(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PQQB
       U=1.0D0
       ZZ=Z
       PHIQQB=DAIND(ZZ,U,PQQB,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END
       REAL*8 FUNCTION PHIBBB(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PBBB
       U=1.0D0
       ZZ=Z
       PHIBBB=DAIND(ZZ,U,PBBB,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END

       REAL*8 FUNCTION PHICCB(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PCCB
       U=1.0D0
       ZZ=Z
       PHICCB=DAIND(ZZ,U,PCCB,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END
       REAL*8 FUNCTION PHIDDB(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PDDB
       U=1.0D0
       ZZ=Z
       PHIDDB=DAIND(ZZ,U,PDDB,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END
       REAL*8 FUNCTION PHICDB(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PCDB
       U=1.0D0
       ZZ=Z
       PHICDB=DAIND(ZZ,U,PCDB,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END

       REAL*8 FUNCTION PHIQQ(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PQQ
       U=1.0D0
       ZZ=Z
       PHIQQ=DAIND(ZZ,U,PQQ,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END

       REAL*8 FUNCTION PHICC(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PCC
       U=1.0D0
       ZZ=Z
       PHICC=DAIND(ZZ,U,PCC,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END
       REAL*8 FUNCTION PHIDD(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PDD
       U=1.0D0
       ZZ=Z
       PHIDD=DAIND(ZZ,U,PDD,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END
       REAL*8 FUNCTION PHICD(Z)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/DAIN/EPS,KEY,MAX
       EXTERNAL PCD
       U=1.0D0
       ZZ=Z
       PHICD=DAIND(ZZ,U,PCD,EPS,KEY,MAX,KOU,EST)
C
C
       RETURN
       END


       REAL*8 FUNCTION PGG(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       HGG=1.0D0/ZZ*GL1*GL2
       PGG=HGG/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PQG(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF
       HQG=GL1*(4.0D0/9.0D0*(U2+U2B+2.0D0*CH2)
     & +1.0D0/9.0D0*(D2+D2B+2.0D0*ST2))
     & +GL2*(4.0D0/9.0D0*(U1+U1B+2.0D0*CH1)
     & +1.0D0/9.0D0*(D1+D1B+2.0D0*ST1))
       HQG=HQG/ZZ
       PQG=HQG/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PQQB(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF
       HQQB= 4.0D0/9.0D0*(U1*U2B+U1B*U2+2.0D0*CH1*CH2)
     &      +1.0D0/9.0D0*(D1*D2B+D1B*D2+2.0D0*ST1*ST2)
       HQQB=HQQB/ZZ
       PQQB=HQQB/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PBBB(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF
       HBBB= 10.0D0/9.0D0*(U1*U2B+U1B*U2+2.0D0*CH1*CH2
     &      +D1*D2B+D1B*D2+2.0D0*ST1*ST2)
       HBBB=HBBB/ZZ
       PBBB=HBBB/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PCCB(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF
       HCCB= 4.0D0/9.0D0*U1*(D2B+ST2+CH2)+1.0D0/9.0D0*D1*(U2B+ST2+CH2)
     &   +1.0D0/9.0D0*ST1*(U2B+D2B+CH2)+4.0D0/9.0D0*CH1*(U2B+D2B+ST2)
     &   +4.0D0/9.0D0*U1B*(D2+ST2+CH2)+1.0D0/9.0D0*D1B*(U2+ST2+CH2)
     &   +1.0D0/9.0D0*ST1*(U2+D2+CH2)+4.0D0/9.0D0*CH1*(U2+D2+ST2)
      
       HCCB=HCCB/ZZ
       PCCB=HCCB/Z1
*
       RETURN
       END
       REAL*8 FUNCTION PDDB(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF

       HDDB= 1.0D0/9.0D0*U1*(D2B+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*D1*(4.0D0*U2B+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*ST1*(4.0D0*U2B+D2B+4.0D0*CH2)
     &   +1.0D0/9.0D0*CH1*(4.0D0*U2B+D2B+ST2)
     &   +1.0D0/9.0D0*U1B*(D2+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*D1B*(4.0D0*U2+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*ST1*(4.0D0*U2+D2+4.0D0*CH2)
     &   +1.0D0/9.0D0*CH1*(4.0D0*U2+D2+ST2)
      
       HDDB=HDDB/ZZ
       PDDB=HDDB/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PCDB(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF

       HCDB= 2.0D0/9.0D0*U1*(D2B+ST2-2.0D0*CH2)
     &   -1.0D0/9.0D0*D1*(-2.0D0*U2B+ST2-2.0D0*CH2)
     &   -1.0D0/9.0D0*ST1*(-2.0D0*U2B+D2B-2.0D0*CH2)
     &   +2.0D0/9.0D0*CH1*(-2.0D0*U2B+D2B+ST2)
     &   -2.0D0/9.0D0*U1B*(-D2-ST2+2.0D0*CH2)
     &   +1.0D0/9.0D0*D1B*(2.0D0*U2-ST2+2.0D0*CH2)
     &   +1.0D0/9.0D0*ST1*(2.0D0*U2-D2+2.0D0*CH2)
     &   -2.0D0/9.0D0*CH1*(2.0D0*U2-D2-ST2)
      
       HCDB=HCDB/ZZ
       PCDB=HCDB/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PQQ(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF
       HQQ= 1.0D0/9.0D0*(4.0D0*U1*U2+4.0D0*U2*U1
     &                  +4.0D0*CH1*CH2+4.0D0*CH2*CH1)
     &     +1.0D0/9.0D0*(D1*D2+D2*D1+ST1*ST2+ST2*ST1)
       HQQ=HQQ/ZZ
       PQQ=HQQ/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PCC(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF
       HCC= 4.0D0/9.0D0*U1*(D2+ST2+CH2)+1.0D0/9.0D0*D1*(U2+ST2+CH2)
     &   +1.0D0/9.0D0*ST1*(U2+D2+CH2)+4.0D0/9.0D0*CH1*(U2+D2+ST2)
     &   +4.0D0/9.0D0*U1B*(D2B+ST2+CH2)+1.0D0/9.0D0*D1B*(U2B+ST2+CH2)
     &   +1.0D0/9.0D0*ST1*(U2B+D2B+CH2)+4.0D0/9.0D0*CH1*(U2B+D2B+ST2)
      
       HCC=HCC/ZZ
       PCC=HCC/Z1
*
       RETURN
       END
       REAL*8 FUNCTION PDD(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF

       HDD= 1.0D0/9.0D0*U1*(D2+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*D1*(4.0D0*U2+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*ST1*(4.0D0*U2+D2+4.0D0*CH2)
     &   +1.0D0/9.0D0*CH1*(4.0D0*U2+D2+ST2)
     &   +1.0D0/9.0D0*U1B*(D2B+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*D1B*(4.0D0*U2B+ST2+4.0D0*CH2)
     &   +1.0D0/9.0D0*ST1*(4.0D0*U2B+D2B+4.0D0*CH2)
     &   +1.0D0/9.0D0*CH1*(4.0D0*U2B+D2B+ST2)
      
       HDD=HDD/ZZ
       PDD=HDD/Z1
*
       RETURN
       END

       REAL*8 FUNCTION PCD(Z1)
*      ------------------------
       IMPLICIT REAL*8 (A-H,O-Z)
       COMMON/VAR2/ ZZ
       COMMON/RIN/XMH,XMUF,XNF
       COMMON/SET/MODE,MODH,MODP
*
       ZBZ1=ZZ/Z1
       CALL STRUCT(Z1,XMUF,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
       CALL STRUCT(ZBZ1,XMUF,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
       IF(MODP.EQ.1) THEN
C 1 =  PROTON, 2 = PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=UV2+US2
       U2B=US2
       D2=DV2+DS2
       D2B=DS2
       ELSEIF(MODP.EQ.2) THEN
C 1 =  PROTON, 2 = ANTI-PROTON
       U1=UV1+US1
       U1B=US1
       D1=DV1+DS1
       D1B=DS1
       U2=US2
       U2B=UV2+US2
       D2=DS2
       D2B=DV2+DS2
       ENDIF

       HCD= 2.0D0/9.0D0*U1*(-D2-ST2+2.0D0*CH2)
     &   -1.0D0/9.0D0*D1*(2.0D0*U2-ST2+2.0D0*CH2)
     &   -1.0D0/9.0D0*ST1*(2.0D0*U2-D2+2.0D0*CH2)
     &   +2.0D0/9.0D0*CH1*(2.0D0*U2-D2-ST2)
     &   -2.0D0/9.0D0*U1B*(D2B+ST2-2.0D0*CH2)
     &   +1.0D0/9.0D0*D1B*(-2.0D0*U2B+ST2-2.0D0*CH2)
     &   +1.0D0/9.0D0*ST1*(-2.0D0*U2B+D2B-2.0D0*CH2)
     &   -2.0D0/9.0D0*CH1*(-2.0D0*U2B+D2B+ST2)
      
       HCD=HCD/ZZ
       PCD=HCD/Z1
*
       RETURN
       END

      REAL*8 FUNCTION CQQB0(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)

      XDEL=1.0D0
      CQQB0=XDEL

      RETURN
      END

      REAL*8 FUNCTION CQQB1R(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM
      COMMON/RIN/XMH,XMUF,XNF
      CF=4.0D0/3.0D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

C
      XM=1.0D0-X
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      XD0=1.0D0/XM

      CQQB1R =
     &  - XL * ( 4.0D0 + 4.0D0*X )
      CQQB1R = CQQB1R - LOGX * (  - 4.0D0 + 8.0D0*XD0 - 4.0D0*X )
      CQQB1R = CQQB1R - LOGXM * ( 8.0D0 + 8.0D0*X )
      CQQB1R=CF*CQQB1R

      RETURN
      END

      REAL*8 FUNCTION CQQB1PLUS(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGXM
      COMMON/RIN/XMH,XMUF,XNF
      CF=4.0D0/3.0D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)


C
      XM=1.0D0-X
C
      LOGXM= DLOG(XM)
      XD0=1.0D0/XM
      XD1=LOGXM/XM

      CQQB1PLUS=8.0D0*XD0*XL+16.0D0*XD1
      CQQB1PLUS=CF*CQQB1PLUS

      RETURN
      END

      REAL*8 FUNCTION CQQB1DEL(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/RIN/XMH,XMUF,XNF
      CF=4.0D0/3.0D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0

C
      XM=1.0D0-X
C
      XDEL=1.0D0

      CQQB1DEL=-XDEL*(-6.0D0*XL-8.0D0*ZETA2+16.0D0)
      CQQB1DEL=CF*CQQB1DEL

      RETURN
      END

      REAL*8 FUNCTION CQG1(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM
      COMMON/RIN/XMH,XMUF,XNF
      TF=0.50D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0

C
      XM=1.0D0-X
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      CQG1 =
     &  + XL * ( 2.0D0*(1.0D0+2.0D0*X**2-2.0D0*X))
      CQG1 = CQG1 + LOGX * (-2.0D0*(1.0D0+2.0D0*X**2-2.0D0*X) )
      CQG1 = CQG1 + LOGXM * (4.0D0*(1.0D0+2.0D0*X**2-2.0D0*X) )
      CQG1 = CQG1 + 1.0D0 + 6.0D0*X - 7.0D0*X**2
      CQG1=TF*CQG1

      RETURN
      END

      REAL*8 FUNCTION CQQB2PLUS(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM
      COMMON/RIN/XMH,XMUF,XNF
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGXM= DLOG(XM)
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQQB2PLUS =
     &  + CF*CA*ZETA2*XL * (  - 16.D0*XD0 )
      CQQB2PLUS = CQQB2PLUS + CF*CA*ZETA2 * ( 176.D0/3.D0*XD0 - 32.D0*
     &    XD1 )
      CQQB2PLUS = CQQB2PLUS + CF*CA*ZETA3 * ( 56.D0*XD0 )
      CQQB2PLUS = CQQB2PLUS + CF*CA*XL * ( 536.D0/9.D0*XD0 - 176.D0/3.D0
     &    *XD1 )
      CQQB2PLUS = CQQB2PLUS + CF*CA*XL**2 * (  - 44.D0/3.D0*XD0 )
      CQQB2PLUS = CQQB2PLUS + CF*CA * (  - 1616.D0/27.D0*XD0 + 1072.D0/
     &    9.D0*XD1 - 176.D0/3.D0*XD2 )
      CQQB2PLUS = CQQB2PLUS + CF*XNF*ZETA2 * (  - 32.D0/3.D0*XD0 )
      CQQB2PLUS = CQQB2PLUS + CF*XNF*XL * (  - 80.D0/9.D0*XD0 + 32.D0/3.
     &    D0*XD1 )
      CQQB2PLUS = CQQB2PLUS + CF*XNF*XL**2 * ( 8.D0/3.D0*XD0 )
      CQQB2PLUS = CQQB2PLUS + CF*XNF * ( 224.D0/27.D0*XD0 - 160.D0/9.D0
     &    *XD1 + 32.D0/3.D0*XD2 )
      CQQB2PLUS = CQQB2PLUS + CF**2*ZETA2*XL * (  - 64.D0*XD0 )
      CQQB2PLUS = CQQB2PLUS + CF**2*ZETA2 * (  - 128.D0*XD1 )
      CQQB2PLUS = CQQB2PLUS + CF**2*ZETA3 * ( 256.D0*XD0 )
      CQQB2PLUS = CQQB2PLUS + CF**2*XL * (  - 128.D0*XD0 + 96.D0*XD1 + 
     &    192.D0*XD2 )
      CQQB2PLUS = CQQB2PLUS + CF**2*XL**2 * ( 48.D0*XD0 + 64.D0*XD1 )
      CQQB2PLUS = CQQB2PLUS + CF**2 * (  - 256.D0*XD1 + 128.D0*XD3 )


      RETURN 
      END

      REAL*8 FUNCTION CQQB2DEL(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/RIN/XMH,XMUF,XNF
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0

C
      XDEL=1.0D0

      CQQB2DEL =
     &  + XDEL*CF*CA*ZETA2 * ( 592.D0/9.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*CA*ZETA2**2 * (  - 12.D0/5.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*CA*ZETA3*XL * (  - 24.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*CA*ZETA3 * ( 28.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*CA*XL * ( 193.D0/3.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*CA*XL**2 * (  - 11.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*CA * (  - 1535.D0/12.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*XNF*ZETA2 * (  - 112.D0/9.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*XNF*ZETA3 * ( 8.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*XNF*XL * (  - 34.D0/3.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*XNF*XL**2 * ( 2.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF*XNF * ( 127.D0/6.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*ZETA2*XL * ( 24.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*ZETA2*XL**2 * (  - 32.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*ZETA2 * (  - 70.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*ZETA2**2 * ( 8.D0/5.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*ZETA3*XL * ( 176.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*ZETA3 * (  - 60.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*XL * (  - 93.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2*XL**2 * ( 18.D0 )
      CQQB2DEL = CQQB2DEL + XDEL*CF**2 * ( 511.D0/4.D0 )

      RETURN
      END

      REAL*8 FUNCTION CQQB2R(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQQB2R =
     &  + CF*CA*ZETA2*XL * ( 8.D0 + 8.D0*X )
      CQQB2R = CQQB2R + CF*CA*ZETA2 * (  - 76.D0/3.D0 - 8.D0*X*LOGX + 
     &    16.D0*X*LOGXM - 100.D0/3.D0*X - 8.D0*LOGX + 16.D0*LOGXM + 16.D
     &    0/(1.D0 - X)*LOGX )
      CQQB2R = CQQB2R + CF*CA*ZETA3 * (  - 28.D0 - 28.D0*X )
      CQQB2R = CQQB2R + CF*CA*XL*XLI2M * ( 8.D0 + 8.D0*X - 16.D0/(1.D0
     &     - X) )
      CQQB2R = CQQB2R + CF*CA*XL * (  - 76.D0/9.D0 - 88.D0/3.D0*X*LOGX
     &     + 88.D0/3.D0*X*LOGXM - 496.D0/9.D0*X - 88.D0/3.D0*LOGX + 88.D
     &    0/3.D0*LOGXM + 140.D0/3.D0/(1.D0 - X)*LOGX )
      CQQB2R = CQQB2R + CF*CA*XL**2 * ( 22.D0/3.D0 + 22.D0/3.D0*X )
      CQQB2R = CQQB2R + CF*CA*XLI2M * (  - 32.D0/3.D0 - 8.D0*X*LOGX + 
     &    16.D0*X*LOGXM - 56.D0/3.D0*X - 8.D0*LOGX + 16.D0*LOGXM + 8.D0/
     &    3.D0/(1.D0 - X) + 16.D0/(1.D0 - X)*LOGX - 16.D0/(1.D0 - X)*
     &    LOGXM )
      CQQB2R = CQQB2R + CF*CA*XLI3M * (  - 24.D0/(1.D0 - X) )
      CQQB2R = CQQB2R + CF*CA*XS12M * ( 20.D0 + 20.D0*X - 8.D0/(1.D0 - 
     &    X) )
      CQQB2R = CQQB2R + CF*CA * (  - 446.D0/27.D0 - 176.D0/3.D0*X*LOGX*
     &    LOGXM + 218.D0/3.D0*X*LOGX + 55.D0/3.D0*X*LOGX**2 - 956.D0/9.D
     &    0*X*LOGXM + 88.D0/3.D0*X*LOGXM**2 + 2278.D0/27.D0*X - 176.D0/
     &    3.D0*LOGX*LOGXM + 52.D0/3.D0*LOGX + 55.D0/3.D0*LOGX**2 - 152.D
     &    0/9.D0*LOGXM + 88.D0/3.D0*LOGXM**2 + 280.D0/3.D0/(1.D0 - X)*
     &    LOGX*LOGXM - 208.D0/3.D0/(1.D0 - X)*LOGX - 29.D0/(1.D0 - X)*
     &    LOGX**2 )
      CQQB2R = CQQB2R + CF*XNF*ZETA2 * ( 16.D0/3.D0 + 16.D0/3.D0*X )
      CQQB2R = CQQB2R + CF*XNF*XL * (  - 8.D0/9.D0 + 16.D0/3.D0*X*LOGX
     &     - 16.D0/3.D0*X*LOGXM + 88.D0/9.D0*X + 16.D0/3.D0*LOGX - 16.D0
     &    /3.D0*LOGXM - 32.D0/3.D0/(1.D0 - X)*LOGX )
      CQQB2R = CQQB2R + CF*XNF*XL**2 * (  - 4.D0/3.D0 - 4.D0/3.D0*X )
      CQQB2R = CQQB2R + CF*XNF*XLI2M * ( 8.D0/3.D0 + 8.D0/3.D0*X - 8.D0/
     &    3.D0/(1.D0 - X) )
      CQQB2R = CQQB2R + CF*XNF * ( 188.D0/27.D0 + 32.D0/3.D0*X*LOGX*
     &    LOGXM - 44.D0/3.D0*X*LOGX - 10.D0/3.D0*X*LOGX**2 + 176.D0/9.D0
     &    *X*LOGXM - 16.D0/3.D0*X*LOGXM**2 - 412.D0/27.D0*X + 32.D0/3.D0
     &    *LOGX*LOGXM - 4.D0/3.D0*LOGX - 10.D0/3.D0*LOGX**2 - 16.D0/9.D0
     &    *LOGXM - 16.D0/3.D0*LOGXM**2 - 64.D0/3.D0/(1.D0 - X)*LOGX*
     &    LOGXM + 40.D0/3.D0/(1.D0 - X)*LOGX + 8.D0/(1.D0 - X)*LOGX**2
     &     )
      CQQB2R = CQQB2R + CF**2*ZETA2*XL * ( 32.D0 + 32.D0*X )
      CQQB2R = CQQB2R + CF**2*ZETA2 * ( 64.D0 - 96.D0*X*LOGX + 64.D0*X*
     &    LOGXM - 64.D0*X - 96.D0*LOGX + 64.D0*LOGXM + 128.D0/(1.D0 - X
     &    )*LOGX )
      CQQB2R = CQQB2R + CF**2*ZETA3 * (  - 128.D0 - 128.D0*X )
      CQQB2R = CQQB2R + CF**2*XL*XLI2M * ( 16.D0 + 16.D0*X + 32.D0/(1.D0
     &     - X) )
      CQQB2R = CQQB2R + CF**2*XL * ( 120.D0 + 144.D0*X*LOGX*LOGXM - 24.D
     &    0*X*LOGX - 36.D0*X*LOGX**2 + 16.D0*X*LOGXM - 96.D0*X*LOGXM**2
     &     + 16.D0*X + 144.D0*LOGX*LOGXM + 56.D0*LOGX - 36.D0*LOGX**2
     &     - 112.D0*LOGXM - 96.D0*LOGXM**2 - 224.D0/(1.D0 - X)*LOGX*
     &    LOGXM - 48.D0/(1.D0 - X)*LOGX + 48.D0/(1.D0 - X)*LOGX**2 )
      CQQB2R = CQQB2R + CF**2*XL**2 * (  - 40.D0 + 24.D0*X*LOGX - 32.D0
     &    *X*LOGXM - 8.D0*X + 24.D0*LOGX - 32.D0*LOGXM - 32.D0/(1.D0 - 
     &    X)*LOGX )
      CQQB2R = CQQB2R + CF**2*XLI2M * (  - 24.D0 + 24.D0*X*LOGX + 24.D0
     &    *X*LOGXM - 32.D0*X + 24.D0*LOGX + 24.D0*LOGXM - 48.D0/(1.D0
     &     - X)*LOGX + 48.D0/(1.D0 - X)*LOGXM )
      CQQB2R = CQQB2R + CF**2*XLI3M * (  - 32.D0 - 32.D0*X - 16.D0/(1.D0
     &     - X) )
      CQQB2R = CQQB2R + CF**2*XS12M * ( 48.D0 + 48.D0*X - 64.D0/(1.D0
     &     - X) )
      CQQB2R = CQQB2R + CF**2 * (  - 72.D0 - 112.D0*X*LOGX*LOGXM + 156.D
     &    0*X*LOGX*LOGXM**2 + 48.D0*X*LOGX - 96.D0*X*LOGX**2*LOGXM + 24.
     &    D0*X*LOGX**2 + 50.D0/3.D0*X*LOGX**3 + 12.D0*X*LOGXM + 64.D0*X
     &    *LOGXM**2 - 64.D0*X*LOGXM**3 + 48.D0*X + 64.D0*LOGX*LOGXM + 
     &    156.D0*LOGX*LOGXM**2 - 104.D0*LOGX - 96.D0*LOGX**2*LOGXM - 8.D
     &    0*LOGX**2 + 50.D0/3.D0*LOGX**3 + 256.D0*LOGXM - 64.D0*
     &    LOGXM**2 - 64.D0*LOGXM**3 - 248.D0/(1.D0 - X)*LOGX*LOGXM**2
     &     + 112.D0/(1.D0 - X)*LOGX + 144.D0/(1.D0 - X)*LOGX**2*LOGXM
     &     - 24.D0/(1.D0 - X)*LOGX**3 )

      RETURN
      END

      REAL*8 FUNCTION CQQBAC(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQQBAC =
     &  + CF*CA*XL*XLI2M * (  - 4.D0 - 4.D0*X + 8.D0/(1.D0 - X) )
      CQQBAC = CQQBAC + CF*CA*XL * ( 16.D0 + 4.D0*X*LOGX - 2.D0*X*
     &    LOGX**2 - 14.D0*X + 4.D0*LOGX - 2.D0*LOGX**2 + 6.D0/(1.D0 - X
     &    )*LOGX + 4.D0/(1.D0 - X)*LOGX**2 )
      CQQBAC = CQQBAC + CF*CA*XLI2M * ( 10.D0 - 8.D0*X*LOGX - 8.D0*X*
     &    LOGXM + 10.D0*X - 8.D0*LOGX - 8.D0*LOGXM + 6.D0/(1.D0 - X) + 
     &    12.D0/(1.D0 - X)*LOGX + 16.D0/(1.D0 - X)*LOGXM )
      CQQBAC = CQQBAC + CF*CA*XLI3M * ( 12.D0 + 12.D0*X - 16.D0/(1.D0
     &     - X) )
      CQQBAC = CQQBAC + CF*CA*XS12M * (  - 18.D0 - 18.D0*X + 36.D0/(1.D0
     &     - X) )
      CQQBAC = CQQBAC + CF*CA * (  - 47.D0 + 8.D0*X*LOGX*LOGXM + 15.D0*
     &    X*LOGX - 4.D0*X*LOGX**2*LOGXM - 2.D0*X*LOGX**2 + X*LOGX**3 - 
     &    28.D0*X*LOGXM + 39.D0*X + 8.D0*LOGX*LOGXM - 16.D0*LOGX - 4.D0
     &    *LOGX**2*LOGXM - 2.D0*LOGX**2 + LOGX**3 + 32.D0*LOGXM + 12.D0
     &    /(1.D0 - X)*LOGX*LOGXM - 12.D0/(1.D0 - X)*LOGX + 8.D0/(1.D0
     &     - X)*LOGX**2*LOGXM - 15.D0/2.D0/(1.D0 - X)*LOGX**2 - 8.D0/3.D
     &    0/(1.D0 - X)*LOGX**3 )
      CQQBAC = CQQBAC + CF**2*XL*XLI2M * ( 8.D0 + 8.D0*X - 16.D0/(1.D0
     &     - X) )
      CQQBAC = CQQBAC + CF**2*XL * (  - 32.D0 - 8.D0*X*LOGX + 4.D0*X*
     &    LOGX**2 + 28.D0*X - 8.D0*LOGX + 4.D0*LOGX**2 - 12.D0/(1.D0 - 
     &    X)*LOGX - 8.D0/(1.D0 - X)*LOGX**2 )
      CQQBAC = CQQBAC + CF**2*XLI2M * (  - 20.D0 + 16.D0*X*LOGX + 16.D0
     &    *X*LOGXM - 20.D0*X + 16.D0*LOGX + 16.D0*LOGXM - 12.D0/(1.D0
     &     - X) - 24.D0/(1.D0 - X)*LOGX - 32.D0/(1.D0 - X)*LOGXM )
      CQQBAC = CQQBAC + CF**2*XLI3M * (  - 24.D0 - 24.D0*X + 32.D0/(1.D0
     &     - X) )
      CQQBAC = CQQBAC + CF**2*XS12M * ( 36.D0 + 36.D0*X - 72.D0/(1.D0
     &     - X) )
      CQQBAC = CQQBAC + CF**2 * ( 94.D0 - 16.D0*X*LOGX*LOGXM - 30.D0*X*
     &    LOGX + 8.D0*X*LOGX**2*LOGXM + 4.D0*X*LOGX**2 - 2.D0*X*LOGX**3
     &     + 56.D0*X*LOGXM - 78.D0*X - 16.D0*LOGX*LOGXM + 32.D0*LOGX + 
     &    8.D0*LOGX**2*LOGXM + 4.D0*LOGX**2 - 2.D0*LOGX**3 - 64.D0*
     &    LOGXM - 24.D0/(1.D0 - X)*LOGX*LOGXM + 24.D0/(1.D0 - X)*LOGX
     &     - 16.D0/(1.D0 - X)*LOGX**2*LOGXM + 15.D0/(1.D0 - X)*LOGX**2
     &     + 16.D0/3.D0/(1.D0 - X)*LOGX**3 )

      RETURN
      END

      REAL*8 FUNCTION CQQBBB(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQQBBB =
     &  + CF*ZETA2 * (  - 32.D0/3.D0*Tf*X - 16.D0/3.D0*Tf*X**2 - 16.D0/
     &    3.D0*Tf )
      CQQBBB = CQQBBB + CF*XLI2MM * (  - 64.D0/3.D0*Tf*X - 32.D0/3.D0*
     &    Tf*X**2 - 32.D0/3.D0*Tf )
      CQQBBB = CQQBBB + CF * (  - 64.D0/3.D0*Tf*X*LOGX*LOGXP + 32.D0/3.D
     &    0*Tf*X*LOGX + 16.D0/3.D0*Tf*X*LOGX**2 - 32.D0/3.D0*Tf*X**2*
     &    LOGX*LOGXP + 8.D0*Tf*X**2*LOGX + 8.D0/3.D0*Tf*X**2*LOGX**2 - 
     &    40.D0/3.D0*Tf*X**2 - 32.D0/3.D0*Tf*LOGX*LOGXP + 8.D0*Tf*LOGX
     &     + 8.D0/3.D0*Tf*LOGX**2 + 40.D0/3.D0*Tf )

      RETURN
      END

      REAL*8 FUNCTION CQQBBC(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQQBBC =
     &  + CF*CA*ZETA2 * (  - 6.D0 - 8.D0*X*LOGX + 24.D0*X*LOGXP - 12.D0
     &    *X - 4.D0*X**2*LOGX + 12.D0*X**2*LOGXP - 6.D0*X**2 - 4.D0*
     &    LOGX + 12.D0*LOGXP )
      CQQBBC = CQQBBC + CF*CA*XLI2M * (  - 18.D0 - 24.D0*X*LOGX - 8.D0*
     &    X**2*LOGX + 18.D0*X**2 - 8.D0*LOGX )
      CQQBBC = CQQBBC + CF*CA*XS12M * (  - 16.D0 - 48.D0*X - 16.D0*X**2
     &     )
      CQQBBC = CQQBBC + CF*CA*XLI2MM * (  - 12.D0 - 24.D0*X*LOGX + 48.D0
     &    *X*LOGXP - 24.D0*X - 12.D0*X**2*LOGX + 24.D0*X**2*LOGXP - 12.D
     &    0*X**2 - 12.D0*LOGX + 24.D0*LOGXP )
      CQQBBC = CQQBBC + CF*CA*XLI3MM * ( 4.D0 + 8.D0*X + 4.D0*X**2 )
      CQQBBC = CQQBBC + CF*CA*XS12MM * ( 24.D0 + 48.D0*X + 24.D0*X**2 )
      CQQBBC = CQQBBC + CF*CA * (  - 27.D0 - 24.D0*X*LOGX*LOGXP + 24.D0
     &    *X*LOGX*LOGXP**2 - 22.D0*X*LOGX - 20.D0*X*LOGX**2*LOGXP + 8.D0
     &    *X*LOGX**2 - 8.D0/3.D0*X*LOGX**3 + 14.D0*X - 12.D0*X**2*LOGX*
     &    LOGXP + 12.D0*X**2*LOGX*LOGXP**2 - 10.D0*X**2*LOGX**2*LOGXP
     &     + 15.D0*X**2*LOGX**2 - 2.D0/3.D0*X**2*LOGX**3 + 13.D0*X**2
     &     - 12.D0*LOGX*LOGXP + 12.D0*LOGX*LOGXP**2 - 18.D0*LOGX - 10.D0
     &    *LOGX**2*LOGXP - 6.D0*LOGX**2 - 2.D0/3.D0*LOGX**3 )
      CQQBBC = CQQBBC + CF**2*ZETA2 * ( 12.D0 + 16.D0*X*LOGX - 48.D0*X*
     &    LOGXP + 24.D0*X + 8.D0*X**2*LOGX - 24.D0*X**2*LOGXP + 12.D0*
     &    X**2 + 8.D0*LOGX - 24.D0*LOGXP )
      CQQBBC = CQQBBC + CF**2*XLI2M * ( 36.D0 + 48.D0*X*LOGX + 16.D0*
     &    X**2*LOGX - 36.D0*X**2 + 16.D0*LOGX )
      CQQBBC = CQQBBC + CF**2*XS12M * ( 32.D0 + 96.D0*X + 32.D0*X**2 )
      CQQBBC = CQQBBC + CF**2*XLI2MM * ( 24.D0 + 48.D0*X*LOGX - 96.D0*X
     &    *LOGXP + 48.D0*X + 24.D0*X**2*LOGX - 48.D0*X**2*LOGXP + 24.D0
     &    *X**2 + 24.D0*LOGX - 48.D0*LOGXP )
      CQQBBC = CQQBBC + CF**2*XLI3MM * (  - 8.D0 - 16.D0*X - 8.D0*X**2
     &     )
      CQQBBC = CQQBBC + CF**2*XS12MM * (  - 48.D0 - 96.D0*X - 48.D0*
     &    X**2 )
      CQQBBC = CQQBBC + CF**2 * ( 54.D0 + 48.D0*X*LOGX*LOGXP - 48.D0*X*
     &    LOGX*LOGXP**2 + 44.D0*X*LOGX + 40.D0*X*LOGX**2*LOGXP - 16.D0*
     &    X*LOGX**2 + 16.D0/3.D0*X*LOGX**3 - 28.D0*X + 24.D0*X**2*LOGX*
     &    LOGXP - 24.D0*X**2*LOGX*LOGXP**2 + 20.D0*X**2*LOGX**2*LOGXP
     &     - 30.D0*X**2*LOGX**2 + 4.D0/3.D0*X**2*LOGX**3 - 26.D0*X**2
     &     + 24.D0*LOGX*LOGXP - 24.D0*LOGX*LOGXP**2 + 36.D0*LOGX + 20.D0
     &    *LOGX**2*LOGXP + 12.D0*LOGX**2 + 4.D0/3.D0*LOGX**3 )

      RETURN
      END

      REAL*8 FUNCTION CQG2(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQG2 =
     &  + CF*ZETA2*XL * ( 16.D0*Tf*X - 16.D0*Tf*X**2 - 8.D0*Tf )
      CQG2 = CQG2 + CF*ZETA2 * (  - 48.D0*Tf*X*LOGX + 32.D0*Tf*X*LOGXM
     &     + 8.D0*Tf*X + 96.D0*Tf*X**2*LOGX - 32.D0*Tf*X**2*LOGXM - 48.D
     &    0*Tf*X**2 + 24.D0*Tf*LOGX - 16.D0*Tf*LOGXM + 20.D0*Tf )
      CQG2 = CQG2 + CF*ZETA3 * (  - 200.D0*Tf*X + 200.D0*Tf*X**2 + 100.D
     &    0*Tf )
      CQG2 = CQG2 + CF*XL*XLI2M * (  - 48.D0*Tf*X**2 )
      CQG2 = CQG2 + CF*XL * ( 80.D0*Tf*X*LOGX*LOGXM - 80.D0*Tf*X*LOGX
     &     - 16.D0*Tf*X*LOGX**2 + 136.D0*Tf*X*LOGXM - 72.D0*Tf*X*
     &    LOGXM**2 - 68.D0*Tf*X - 128.D0*Tf*X**2*LOGX*LOGXM + 92.D0*Tf*
     &    X**2*LOGX + 32.D0*Tf*X**2*LOGX**2 - 92.D0*Tf*X**2*LOGXM + 72.D
     &    0*Tf*X**2*LOGXM**2 + 22.D0*Tf*X**2 - 40.D0*Tf*LOGX*LOGXM + 10.
     &    D0*Tf*LOGX + 8.D0*Tf*LOGX**2 - 32.D0*Tf*LOGXM + 36.D0*Tf*
     &    LOGXM**2 + 24.D0*Tf )
      CQG2 = CQG2 + CF*XL**2 * ( 12.D0*Tf*X*LOGX - 24.D0*Tf*X*LOGXM + 
     &    12.D0*Tf*X - 24.D0*Tf*X**2*LOGX + 24.D0*Tf*X**2*LOGXM - 6.D0*
     &    Tf*LOGX + 12.D0*Tf*LOGXM - 3.D0*Tf )
      CQG2 = CQG2 + CF*XLI2M * (  - 8.D0*Tf*X*LOGX + 24.D0*Tf*X*LOGXM
     &     - 48.D0*Tf*X - 104.D0*Tf*X**2*LOGXM + 80.D0*Tf*X**2 + 4.D0*
     &    Tf*LOGX - 12.D0*Tf*LOGXM - 18.D0*Tf )
      CQG2 = CQG2 + CF*XLI3M * ( 8.D0*Tf*X + 72.D0*Tf*X**2 - 4.D0*Tf )
      CQG2 = CQG2 + CF*XS12M * ( 88.D0*Tf*X - 136.D0*Tf*X**2 - 44.D0*Tf
     &     )
      CQG2 = CQG2 + CF*XLI2MM * ( 32.D0*Tf*X*LOGX - 32.D0*Tf*X - 32.D0*
     &    Tf*X**2*LOGX - 48.D0*Tf*X**2 - 16.D0*Tf*LOGX + 16.D0*Tf )
      CQG2 = CQG2 + CF*XLI3MM * (  - 64.D0*Tf*X + 64.D0*Tf*X**2 + 32.D0
     &    *Tf )
      CQG2 = CQG2 + CF * (  - 192.D0*Tf*X*LOGX*LOGXM + 84.D0*Tf*X*LOGX*
     &    LOGXM**2 - 32.D0*Tf*X*LOGX*LOGXP + 201.D0*Tf*X*LOGX - 48.D0*
     &    Tf*X*LOGX**2*LOGXM + 30.D0*Tf*X*LOGX**2 + 34.D0/3.D0*Tf*X*
     &    LOGX**3 - 270.D0*Tf*X*LOGXM + 160.D0*Tf*X*LOGXM**2 - 140.D0/3.
     &    D0*Tf*X*LOGXM**3 + 221.D0*Tf*X + 192.D0*Tf*X**2*LOGX*LOGXM - 
     &    132.D0*Tf*X**2*LOGX*LOGXM**2 - 48.D0*Tf*X**2*LOGX*LOGXP - 174.
     &    D0*Tf*X**2*LOGX + 80.D0*Tf*X**2*LOGX**2*LOGXM - 2.D0*Tf*X**2*
     &    LOGX**2 - 52.D0/3.D0*Tf*X**2*LOGX**3 + 176.D0*Tf*X**2*LOGXM
     &     - 126.D0*Tf*X**2*LOGXM**2 + 140.D0/3.D0*Tf*X**2*LOGXM**3 - 
     &    305.D0/2.D0*Tf*X**2 + 28.D0*Tf*LOGX*LOGXM - 42.D0*Tf*LOGX*
     &    LOGXM**2 + 16.D0*Tf*LOGX*LOGXP - 31.D0*Tf*LOGX + 24.D0*Tf*
     &    LOGX**2*LOGXM - 11.D0/2.D0*Tf*LOGX**2 - 17.D0/3.D0*Tf*LOGX**3
     &     + 52.D0*Tf*LOGXM - 46.D0*Tf*LOGXM**2 + 70.D0/3.D0*Tf*
     &    LOGXM**3 - 157.D0/2.D0*Tf )
      CQG2 = CQG2 + CA*ZETA2*XL * ( 16.D0*Tf*X - 32.D0*Tf*X**2 - 16.D0*
     &    Tf )
      CQG2 = CQG2 + CA*ZETA2 * (  - 32.D0/3.D0*x**(-1)*Tf - 80.D0*Tf*X*
     &    LOGX + 32.D0*Tf*X*LOGXM - 112.D0*Tf*X + 32.D0*Tf*X**2*LOGX - 
     &    64.D0*Tf*X**2*LOGXM + 428.D0/3.D0*Tf*X**2 - 32.D0*Tf*LOGXM + 
     &    20.D0*Tf )
      CQG2 = CQG2 + CA*ZETA3 * (  - 16.D0*Tf*X - 8.D0*Tf*X**2 - 4.D0*Tf
     &     )
      CQG2 = CQG2 + CA*XL*XLI2M * ( 48.D0*Tf*X + 16.D0*Tf*X**2 + 24.D0*
     &    Tf )
      CQG2 = CQG2 + CA*XL*XLI2MM * (  - 16.D0*Tf*X - 16.D0*Tf*X**2 - 8.D
     &    0*Tf )
      CQG2 = CQG2 + CA*XL * ( 32.D0/3.D0*x**(-1)*Tf*LOGXM + 88.D0/9.D0*
     &    x**(-1)*Tf + 80.D0*Tf*X*LOGX*LOGXM - 16.D0*Tf*X*LOGX*LOGXP - 
     &    8.D0*Tf*X*LOGX - 24.D0*Tf*X*LOGX**2 + 72.D0*Tf*X*LOGXM - 24.D0
     &    *Tf*X*LOGXM**2 - 8.D0/3.D0*Tf*X - 16.D0*Tf*X**2*LOGX*LOGXM - 
     &    16.D0*Tf*X**2*LOGX*LOGXP + 112.D0*Tf*X**2*LOGX - 284.D0/3.D0*
     &    Tf*X**2*LOGXM + 24.D0*Tf*X**2*LOGXM**2 + 146.D0/9.D0*Tf*X**2
     &     + 8.D0*Tf*LOGX*LOGXM - 8.D0*Tf*LOGX*LOGXP + 12.D0*Tf*LOGX - 
     &    8.D0*Tf*LOGX**2 + 12.D0*Tf*LOGXM + 12.D0*Tf*LOGXM**2 - 58.D0/
     &    3.D0*Tf )
      CQG2 = CQG2 + CA*XL**2 * ( 8.D0/3.D0*x**(-1)*Tf + 16.D0*Tf*X*LOGX
     &     - 8.D0*Tf*X*LOGXM + 16.D0*Tf*X + 8.D0*Tf*X**2*LOGXM - 62.D0/
     &    3.D0*Tf*X**2 + 4.D0*Tf*LOGX + 4.D0*Tf*LOGXM + 2.D0*Tf )
      CQG2 = CQG2 + CA*XLI2M * ( 64.D0/3.D0*x**(-1)*Tf + 56.D0*Tf*X*
     &    LOGX + 80.D0*Tf*X*LOGXM + 128.D0*Tf*X - 16.D0*Tf*X**2*LOGX + 
     &    40.D0*Tf*X**2*LOGXM + 176.D0/3.D0*Tf*X**2 + 56.D0*Tf*LOGXM + 
     &    44.D0*Tf )
      CQG2 = CQG2 + CA*XLI3M * (  - 136.D0*Tf*X - 48.D0*Tf*X**2 - 60.D0
     &    *Tf )
      CQG2 = CQG2 + CA*XS12M * ( 128.D0*Tf*X + 32.D0*Tf*X**2 + 72.D0*Tf
     &     )
      CQG2 = CQG2 + CA*XLI2MM * ( 32.D0*Tf*X*LOGX - 32.D0*Tf*X*LOGXM + 
     &    40.D0*Tf*X + 32.D0*Tf*X**2*LOGX - 32.D0*Tf*X**2*LOGXM + 32.D0
     &    *Tf*X**2 + 16.D0*Tf*LOGX - 16.D0*Tf*LOGXM + 8.D0*Tf )
      CQG2 = CQG2 + CA*XLI3MM * (  - 16.D0*Tf*X - 16.D0*Tf*X**2 - 8.D0*
     &    Tf )
      CQG2 = CQG2 + CA*XLI3NM * (  - 32.D0*Tf*X - 32.D0*Tf*X**2 - 16.D0
     &    *Tf )
      CQG2 = CQG2 + CA*XLI3NP * ( 32.D0*Tf*X + 32.D0*Tf*X**2 + 16.D0*Tf
     &     )
      CQG2 = CQG2 + CA * ( 176.D0/9.D0*x**(-1)*Tf*LOGXM + 32.D0/3.D0*
     &    x**(-1)*Tf*LOGXM**2 + 116.D0/27.D0*x**(-1)*Tf - 32.D0*Tf*X*
     &    LOGX*LOGXM*LOGXP - 32.D0*Tf*X*LOGX*LOGXM + 88.D0*Tf*X*LOGX*
     &    LOGXM**2 + 40.D0*Tf*X*LOGX*LOGXP - 32.D0/3.D0*Tf*X*LOGX - 56.D
     &    0*Tf*X*LOGX**2*LOGXM + 24.D0*Tf*X*LOGX**2*LOGXP - 4.D0*Tf*X*
     &    LOGX**2 + 40.D0/3.D0*Tf*X*LOGX**3 + 50.D0/3.D0*Tf*X*LOGXM + 
     &    84.D0*Tf*X*LOGXM**2 - 52.D0/3.D0*Tf*X*LOGXM**3 - 1226.D0/9.D0
     &    *Tf*X - 32.D0*Tf*X**2*LOGX*LOGXM*LOGXP + 260.D0*Tf*X**2*LOGX*
     &    LOGXM - 24.D0*Tf*X**2*LOGX*LOGXM**2 + 32.D0*Tf*X**2*LOGX*
     &    LOGXP - 914.D0/9.D0*Tf*X**2*LOGX + 8.D0*Tf*X**2*LOGX**2*LOGXM
     &     + 24.D0*Tf*X**2*LOGX**2*LOGXP - 346.D0/3.D0*Tf*X**2*LOGX**2
     &     + 148.D0/9.D0*Tf*X**2*LOGXM - 308.D0/3.D0*Tf*X**2*LOGXM**2
     &     + 52.D0/3.D0*Tf*X**2*LOGXM**3 + 1837.D0/27.D0*Tf*X**2 - 16.D0
     &    *Tf*LOGX*LOGXM*LOGXP + 20.D0*Tf*LOGX*LOGXM + 4.D0*Tf*LOGX*
     &    LOGXM**2 + 8.D0*Tf*LOGX*LOGXP + 236.D0/3.D0*Tf*LOGX - 12.D0*
     &    Tf*LOGX**2*LOGXM )
      CQG2 = CQG2 + CA * ( 12.D0*Tf*LOGX**2*LOGXP - 5.D0*Tf*LOGX**2 + 6.
     &    D0*Tf*LOGX**3 - 140.D0/3.D0*Tf*LOGXM + 8.D0*Tf*LOGXM**2 + 26.D
     &    0/3.D0*Tf*LOGXM**3 + 539.D0/9.D0*Tf )

      RETURN
      END

      REAL*8 FUNCTION CQ1Q2CC(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQ1Q2CC =
     &  + CF*ZETA2 * (  - 32.D0/3.D0*x**(-1)*Tf - 16.D0*Tf*X*LOGX + 8.D0
     &    *Tf*X + 32.D0/3.D0*Tf*X**2 - 16.D0*Tf*LOGX - 8.D0*Tf )
      CQ1Q2CC = CQ1Q2CC + CF*XL*XLI2M * ( 16.D0*Tf*X + 16.D0*Tf )
      CQ1Q2CC = CQ1Q2CC + CF*XL * ( 32.D0/3.D0*x**(-1)*Tf*LOGXM + 88.D0/
     &    9.D0*x**(-1)*Tf + 16.D0*Tf*X*LOGX*LOGXM + 24.D0*Tf*X*LOGX - 8.
     &    D0*Tf*X*LOGX**2 - 8.D0*Tf*X*LOGXM + 52.D0/3.D0*Tf*X + 16.D0*
     &    Tf*X**2*LOGX - 32.D0/3.D0*Tf*X**2*LOGXM - 88.D0/9.D0*Tf*X**2
     &     + 16.D0*Tf*LOGX*LOGXM + 12.D0*Tf*LOGX - 8.D0*Tf*LOGX**2 + 8.D
     &    0*Tf*LOGXM - 52.D0/3.D0*Tf )
      CQ1Q2CC = CQ1Q2CC + CF*XL**2 * ( 8.D0/3.D0*x**(-1)*Tf + 4.D0*Tf*X
     &    *LOGX - 2.D0*Tf*X - 8.D0/3.D0*Tf*X**2 + 4.D0*Tf*LOGX + 2.D0*
     &    Tf )
      CQ1Q2CC = CQ1Q2CC + CF*XLI2M * ( 64.D0/3.D0*x**(-1)*Tf + 8.D0*Tf*
     &    X*LOGX + 32.D0*Tf*X*LOGXM + 20.D0*Tf*X + 32.D0/3.D0*Tf*X**2
     &     + 8.D0*Tf*LOGX + 32.D0*Tf*LOGXM + 52.D0*Tf )
      CQ1Q2CC = CQ1Q2CC + CF*XLI3M * (  - 32.D0*Tf*X - 32.D0*Tf )
      CQ1Q2CC = CQ1Q2CC + CF*XS12M * ( 48.D0*Tf*X + 48.D0*Tf )
      CQ1Q2CC = CQ1Q2CC + CF * ( 176.D0/9.D0*x**(-1)*Tf*LOGXM + 32.D0/3.
     &    D0*x**(-1)*Tf*LOGXM**2 + 116.D0/27.D0*x**(-1)*Tf + 48.D0*Tf*X
     &    *LOGX*LOGXM + 16.D0*Tf*X*LOGX*LOGXM**2 - 32.D0/3.D0*Tf*X*LOGX
     &     - 16.D0*Tf*X*LOGX**2*LOGXM - 25.D0*Tf*X*LOGX**2 + 6.D0*Tf*X*
     &    LOGX**3 + 104.D0/3.D0*Tf*X*LOGXM - 8.D0*Tf*X*LOGXM**2 - 866.D0
     &    /9.D0*Tf*X + 32.D0*Tf*X**2*LOGX*LOGXM + 40.D0/9.D0*Tf*X**2*
     &    LOGX - 40.D0/3.D0*Tf*X**2*LOGX**2 - 176.D0/9.D0*Tf*X**2*LOGXM
     &     - 32.D0/3.D0*Tf*X**2*LOGXM**2 + 703.D0/27.D0*Tf*X**2 + 24.D0
     &    *Tf*LOGX*LOGXM + 16.D0*Tf*LOGX*LOGXM**2 + 230.D0/3.D0*Tf*LOGX
     &     - 16.D0*Tf*LOGX**2*LOGXM - 5.D0*Tf*LOGX**2 + 6.D0*Tf*LOGX**3
     &     - 104.D0/3.D0*Tf*LOGXM + 8.D0*Tf*LOGXM**2 + 593.D0/9.D0*Tf )


      RETURN
      END

      REAL*8 FUNCTION CQ1Q2CD(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CQ1Q2CD =
     &  + CF*ZETA2 * (  - 96.D0*x**(-1)*Tf*LOGXP + 8.D0*Tf*X*LOGX - 48.D
     &    0*Tf*X*LOGXP + 40.D0*Tf*X + 80.D0*Tf*LOGX - 96.D0*Tf*LOGXP + 
     &    40.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF*ZETA3 * (  - 96.D0*x**(-1)*Tf - 24.D0*Tf*X
     &     + 144.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF*XLI2M * (  - 8.D0*Tf*X*LOGX - 32.D0*Tf*X
     &     + 80.D0*Tf*LOGX + 40.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF*XLI3M * ( 32.D0*x**(-1)*Tf + 24.D0*Tf*X - 
     &    48.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF*XS12M * ( 64.D0*x**(-1)*Tf + 32.D0*Tf*X + 
     &    64.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF*XLI2MM * ( 160.D0*x**(-1)*Tf*LOGX - 192.D0
     &    *x**(-1)*Tf*LOGXP + 64.D0*Tf*X*LOGX - 96.D0*Tf*X*LOGXP + 80.D0
     &    *Tf*X - 192.D0*Tf*LOGXP + 80.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF*XLI3MM * (  - 160.D0*x**(-1)*Tf - 48.D0*Tf
     &    *X + 160.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF*XS12MM * (  - 192.D0*x**(-1)*Tf - 96.D0*Tf
     &    *X - 192.D0*Tf )
      CQ1Q2CD = CQ1Q2CD + CF * (  - 96.D0*x**(-1)*Tf*LOGX*LOGXP**2 + 80.
     &    D0*x**(-1)*Tf*LOGX**2*LOGXP + 80.D0*Tf*X*LOGX*LOGXP - 48.D0*
     &    Tf*X*LOGX*LOGXP**2 - 64.D0*Tf*X*LOGX + 40.D0*Tf*X*LOGX**2*
     &    LOGXP - 52.D0*Tf*X*LOGX**2 - 16.D0/3.D0*Tf*X*LOGX**3 + 160.D0
     &    *Tf*X + 80.D0*Tf*LOGX*LOGXP - 96.D0*Tf*LOGX*LOGXP**2 - 80.D0*
     &    Tf*LOGX + 80.D0*Tf*LOGX**2*LOGXP - 160.D0*Tf )

      RETURN
      END

      REAL*8 FUNCTION CQQCE(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM



      CQQCE =
     &  + CF*CA*ZETA2*XL * (  - 4.D0 + 4.D0*X + 8.D0/(1.D0 + X) )
      CQQCE = CQQCE + CF*CA*ZETA2 * (  - 2.D0 - 4.D0*X*LOGX + 8.D0*X*
     &    LOGXM - 2.D0*X + 4.D0*LOGX - 8.D0*LOGXM - 12.D0/(1.D0 + X)*
     &    LOGX + 16.D0/(1.D0 + X)*LOGXM + 8.D0/(1.D0 + X)*LOGXP )
      CQQCE = CQQCE + CF*CA*ZETA3 * (  - 6.D0 + 6.D0*X + 4.D0/(1.D0 + X
     &    ) )
      CQQCE = CQQCE + CF*CA*XL*XLI2MM * (  - 8.D0 + 8.D0*X + 16.D0/(1.D0
     &     + X) )
      CQQCE = CQQCE + CF*CA*XL * (  - 8.D0 + 8.D0*X*LOGX*LOGXP - 4.D0*X
     &    *LOGX - 2.D0*X*LOGX**2 + 8.D0*X - 8.D0*LOGX*LOGXP - 4.D0*LOGX
     &     + 2.D0*LOGX**2 + 16.D0/(1.D0 + X)*LOGX*LOGXP - 4.D0/(1.D0 + 
     &    X)*LOGX**2 )
      CQQCE = CQQCE + CF*CA*XLI2M * (  - 12.D0 - 12.D0*X*LOGX - 4.D0*X
     &     + 12.D0*LOGX - 24.D0/(1.D0 + X)*LOGX )
      CQQCE = CQQCE + CF*CA*XLI3M * (  - 16.D0 + 16.D0*X + 32.D0/(1.D0
     &     + X) )
      CQQCE = CQQCE + CF*CA*XS12M * ( 16.D0 - 16.D0*X - 32.D0/(1.D0 + X
     &    ) )
      CQQCE = CQQCE + CF*CA*XLI2MM * (  - 4.D0 - 16.D0*X*LOGX + 16.D0*X
     &    *LOGXM - 4.D0*X + 16.D0*LOGX - 16.D0*LOGXM - 32.D0/(1.D0 + X)
     &    *LOGX + 32.D0/(1.D0 + X)*LOGXM + 16.D0/(1.D0 + X)*LOGXP )
      CQQCE = CQQCE + CF*CA*XLI3MM * (  - 8.D0 + 8.D0*X + 8.D0/(1.D0 + 
     &    X) )
      CQQCE = CQQCE + CF*CA*XS12MM * ( 16.D0/(1.D0 + X) )
      CQQCE = CQQCE + CF*CA*XLI3NM * (  - 16.D0 + 16.D0*X + 32.D0/(1.D0
     &     + X) )
      CQQCE = CQQCE + CF*CA*XLI3NP * ( 16.D0 - 16.D0*X - 32.D0/(1.D0 + 
     &    X) )
      CQQCE = CQQCE + CF*CA * ( 17.D0 + 16.D0*X*LOGX*LOGXM*LOGXP - 8.D0
     &    *X*LOGX*LOGXM - 4.D0*X*LOGX*LOGXP - 7.D0*X*LOGX - 4.D0*X*
     &    LOGX**2*LOGXM - 12.D0*X*LOGX**2*LOGXP + 6.D0*X*LOGX**2 + X*
     &    LOGX**3 + 16.D0*X*LOGXM - 17.D0*X - 16.D0*LOGX*LOGXM*LOGXP - 
     &    8.D0*LOGX*LOGXM - 4.D0*LOGX*LOGXP + 9.D0*LOGX + 4.D0*LOGX**2*
     &    LOGXM + 12.D0*LOGX**2*LOGXP + 2.D0*LOGX**2 - LOGX**3 - 16.D0*
     &    LOGXM + 32.D0/(1.D0 + X)*LOGX*LOGXM*LOGXP + 8.D0/(1.D0 + X)*
     &    LOGX*LOGXP**2 - 8.D0/(1.D0 + X)*LOGX**2*LOGXM - 28.D0/(1.D0
     &     + X)*LOGX**2*LOGXP + 8.D0/3.D0/(1.D0 + X)*LOGX**3 )
      CQQCE = CQQCE + CF**2*ZETA2*XL * ( 8.D0 - 8.D0*X - 16.D0/(1.D0 + 
     &    X) )
      CQQCE = CQQCE + CF**2*ZETA2 * ( 4.D0 + 8.D0*X*LOGX - 16.D0*X*
     &    LOGXM + 4.D0*X - 8.D0*LOGX + 16.D0*LOGXM + 24.D0/(1.D0 + X)*
     &    LOGX - 32.D0/(1.D0 + X)*LOGXM - 16.D0/(1.D0 + X)*LOGXP )
      CQQCE = CQQCE + CF**2*ZETA3 * ( 12.D0 - 12.D0*X - 8.D0/(1.D0 + X)
     &     )
      CQQCE = CQQCE + CF**2*XL*XLI2MM * ( 16.D0 - 16.D0*X - 32.D0/(1.D0
     &     + X) )
      CQQCE = CQQCE + CF**2*XL * ( 16.D0 - 16.D0*X*LOGX*LOGXP + 8.D0*X*
     &    LOGX + 4.D0*X*LOGX**2 - 16.D0*X + 16.D0*LOGX*LOGXP + 8.D0*
     &    LOGX - 4.D0*LOGX**2 - 32.D0/(1.D0 + X)*LOGX*LOGXP + 8.D0/(1.D0
     &     + X)*LOGX**2 )
      CQQCE = CQQCE + CF**2*XLI2M * ( 24.D0 + 24.D0*X*LOGX + 8.D0*X - 
     &    24.D0*LOGX + 48.D0/(1.D0 + X)*LOGX )
      CQQCE = CQQCE + CF**2*XLI3M * ( 32.D0 - 32.D0*X - 64.D0/(1.D0 + X
     &    ) )
      CQQCE = CQQCE + CF**2*XS12M * (  - 32.D0 + 32.D0*X + 64.D0/(1.D0
     &     + X) )
      CQQCE = CQQCE + CF**2*XLI2MM * ( 8.D0 + 32.D0*X*LOGX - 32.D0*X*
     &    LOGXM + 8.D0*X - 32.D0*LOGX + 32.D0*LOGXM + 64.D0/(1.D0 + X)*
     &    LOGX - 64.D0/(1.D0 + X)*LOGXM - 32.D0/(1.D0 + X)*LOGXP )
      CQQCE = CQQCE + CF**2*XLI3MM * ( 16.D0 - 16.D0*X - 16.D0/(1.D0 + 
     &    X) )
      CQQCE = CQQCE + CF**2*XS12MM * (  - 32.D0/(1.D0 + X) )
      CQQCE = CQQCE + CF**2*XLI3NM * ( 32.D0 - 32.D0*X - 64.D0/(1.D0 + 
     &    X) )
      CQQCE = CQQCE + CF**2*XLI3NP * (  - 32.D0 + 32.D0*X + 64.D0/(1.D0
     &     + X) )
      CQQCE = CQQCE + CF**2 * (  - 34.D0 - 32.D0*X*LOGX*LOGXM*LOGXP + 
     &    16.D0*X*LOGX*LOGXM + 8.D0*X*LOGX*LOGXP + 14.D0*X*LOGX + 8.D0*
     &    X*LOGX**2*LOGXM + 24.D0*X*LOGX**2*LOGXP - 12.D0*X*LOGX**2 - 2.
     &    D0*X*LOGX**3 - 32.D0*X*LOGXM + 34.D0*X + 32.D0*LOGX*LOGXM*
     &    LOGXP + 16.D0*LOGX*LOGXM + 8.D0*LOGX*LOGXP - 18.D0*LOGX - 8.D0
     &    *LOGX**2*LOGXM - 24.D0*LOGX**2*LOGXP - 4.D0*LOGX**2 + 2.D0*
     &    LOGX**3 + 32.D0*LOGXM - 64.D0/(1.D0 + X)*LOGX*LOGXM*LOGXP - 
     &    16.D0/(1.D0 + X)*LOGX*LOGXP**2 + 16.D0/(1.D0 + X)*LOGX**2*
     &    LOGXM + 56.D0/(1.D0 + X)*LOGX**2*LOGXP - 16.D0/3.D0/(1.D0 + X
     &    )*LOGX**3 )

      RETURN
      END

      REAL*8 FUNCTION CQQCF(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM
      CQQCF =
     &  + CF*CA*XLI2M * ( 6.D0 - 8.D0*X*LOGX - 12.D0*X + 4.D0*X**2*LOGX
     &     + 6.D0*X**2 + 4.D0*LOGX )
      CQQCF = CQQCF + CF*CA*XLI3M * (  - 4.D0 + 8.D0*X - 4.D0*X**2 )
      CQQCF = CQQCF + CF*CA*XS12M * ( 4.D0 - 8.D0*X + 4.D0*X**2 )
      CQQCF = CQQCF + CF*CA * ( 15.D0/2.D0 - 6.D0*X*LOGX - 6.D0*X*
     &    LOGX**2 - 4.D0/3.D0*X*LOGX**3 - 14.D0*X + 3.D0*X**2*LOGX**2
     &     + 2.D0/3.D0*X**2*LOGX**3 + 13.D0/2.D0*X**2 + 7.D0*LOGX + 3.D0
     &    *LOGX**2 + 2.D0/3.D0*LOGX**3 )
      CQQCF = CQQCF + CF**2*XLI2M * (  - 12.D0 + 16.D0*X*LOGX + 24.D0*X
     &     - 8.D0*X**2*LOGX - 12.D0*X**2 - 8.D0*LOGX )
      CQQCF = CQQCF + CF**2*XLI3M * ( 8.D0 - 16.D0*X + 8.D0*X**2 )
      CQQCF = CQQCF + CF**2*XS12M * (  - 8.D0 + 16.D0*X - 8.D0*X**2 )
      CQQCF = CQQCF + CF**2 * (  - 15.D0 + 12.D0*X*LOGX + 12.D0*X*
     &    LOGX**2 + 8.D0/3.D0*X*LOGX**3 + 28.D0*X - 6.D0*X**2*LOGX**2
     &     - 4.D0/3.D0*X**2*LOGX**3 - 13.D0*X**2 - 14.D0*LOGX - 6.D0*
     &    LOGX**2 - 4.D0/3.D0*LOGX**3 )

      RETURN
      END

      REAL*8 FUNCTION CGG2(X)
C     -----------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 LOGX,LOGXM,LOGXP
      COMMON/RIN/XMH,XMUF,XNF
      EXTERNAL FLI2,FLI3,S12
      CF=4.0D0/3.0D0
      CA=3.0D0
      XNC=CA
      TF=0.50D0
      XNC2M=XNC**2-1.0D0
      XMT=173.40D0

      XMH2=XMH*XMH
      XMUF2=XMUF*XMUF
      XL=DLOG(XMH2/XMUF2)

      PI = 3.141592653589793238462643D0
      ZETA2 = PI**2/6.0D0
      ZETA3 = 1.20205690315959428540D0
      GE   = 0.57721566490153D+0

C
      XM=1.0D0-X
      XP=1.0D0+X
      XMP=XM/XP
C
      LOGX = DLOG(X)
      LOGXM= DLOG(XM)
      LOGXP= DLOG(XP)
      XLI2M=FLI2(XM)
      XLI3M=FLI3(XM)
      XS12M= S12(XM)
      XLI2MM=FLI2(-X)
      XLI3MM=FLI3(-X)
      XS12MM= S12(-X)
      XLI3NM=FLI3(-XMP)
      XLI3NP=FLI3(XMP)
      XDEL=1.0D0
      XD0=1.0D0/XM
      XD1=LOGXM/XM
      XD2=LOGXM**2/XM
      XD3=LOGXM**3/XM

      CGG2 =
     &  + XNC**2*XNC2M**(-1)*ZETA2 * ( 8.D0/3.D0 + 16.D0*X*LOGXP + 16.D0
     &    /3.D0*X + 8.D0*X**2*LOGXP + 8.D0/3.D0*X**2 + 8.D0*LOGXP )
      CGG2 = CGG2 + XNC**2*XNC2M**(-1)*ZETA3 * ( 16.D0 + 32.D0*X + 16.D0
     &    *X**2 )
      CGG2 = CGG2 + XNC**2*XNC2M**(-1)*XS12M * (  - 8.D0 + 16.D0*X - 8.D
     &    0*X**2 )
      CGG2 = CGG2 + XNC**2*XNC2M**(-1)*XLI2MM * ( 16.D0/3.D0 - 48.D0*X*
     &    LOGX + 32.D0*X*LOGXP + 32.D0/3.D0*X - 24.D0*X**2*LOGX + 16.D0
     &    *X**2*LOGXP + 16.D0/3.D0*X**2 - 24.D0*LOGX + 16.D0*LOGXP )
      CGG2 = CGG2 + XNC**2*XNC2M**(-1)*XLI3MM * ( 24.D0 + 48.D0*X + 24.D
     &    0*X**2 )
      CGG2 = CGG2 + XNC**2*XNC2M**(-1)*XS12MM * ( 16.D0 + 32.D0*X + 16.D
     &    0*X**2 )
      CGG2 = CGG2 + XNC**2*XNC2M**(-1) * (  - 47.D0/3.D0 + 32.D0/3.D0*X
     &    *LOGX*LOGXP + 16.D0*X*LOGX*LOGXP**2 - 76.D0/3.D0*X*LOGX - 24.D
     &    0*X*LOGX**2*LOGXP + 4.D0/3.D0*X*LOGX**2 - 48.D0*X + 16.D0/3.D0
     &    *X**2*LOGX*LOGXP + 8.D0*X**2*LOGX*LOGXP**2 - 50.D0*X**2*LOGX
     &     - 12.D0*X**2*LOGX**2*LOGXP + 50.D0/3.D0*X**2*LOGX**2 + 191.D0
     &    /3.D0*X**2 + 16.D0/3.D0*LOGX*LOGXP + 8.D0*LOGX*LOGXP**2 - 4.D0
     &    *LOGX - 12.D0*LOGX**2*LOGXP - 4.D0/3.D0*LOGX**2 )
      CGG2 = CGG2 + ZETA2 * ( 20.D0 + 40.D0*X*LOGX - 16.D0*X*LOGXP + 36.
     &    D0*X + 40.D0*X**2*LOGX - 8.D0*X**2*LOGXP - 48.D0*X**2 + 12.D0
     &    *LOGX - 8.D0*LOGXP )
      CGG2 = CGG2 + ZETA3 * (  - 4.D0 - 8.D0*X + 8.D0*X**2 )
      CGG2 = CGG2 + XL*XLI2M * (  - 8.D0 - 32.D0*X - 32.D0*X**2 )
      CGG2 = CGG2 + XL * ( 7.D0 - 32.D0*X*LOGX*LOGXM + 16.D0*X*LOGX + 8.
     &    D0*X*LOGX**2 - 32.D0*X*LOGXM + 60.D0*X - 32.D0*X**2*LOGX*
     &    LOGXM - 8.D0*X**2*LOGX + 8.D0*X**2*LOGX**2 + 48.D0*X**2*LOGXM
     &     - 67.D0*X**2 - 8.D0*LOGX*LOGXM + 2.D0*LOGX + 2.D0*LOGX**2 - 
     &    16.D0*LOGXM )
      CGG2 = CGG2 + XL**2 * (  - 4.D0 - 8.D0*X*LOGX - 8.D0*X - 8.D0*
     &    X**2*LOGX + 12.D0*X**2 - 2.D0*LOGX )
      CGG2 = CGG2 + XLI2M * (  - 20.D0 - 16.D0*X*LOGX - 64.D0*X*LOGXM
     &     - 16.D0*X - 16.D0*X**2*LOGX - 64.D0*X**2*LOGXM + 56.D0*X**2
     &     - 4.D0*LOGX - 16.D0*LOGXM )
      CGG2 = CGG2 + XLI3M * ( 16.D0 + 64.D0*X + 64.D0*X**2 )
      CGG2 = CGG2 + XS12M * (  - 8.D0 - 80.D0*X - 56.D0*X**2 )
      CGG2 = CGG2 + XLI2MM * ( 8.D0 + 32.D0*X*LOGX - 32.D0*X*LOGXP + 8.D
     &    0*X + 8.D0*X**2*LOGX - 16.D0*X**2*LOGXP + 16.D0*LOGX - 16.D0*
     &    LOGXP )
      CGG2 = CGG2 + XLI3MM * (  - 8.D0 - 16.D0*X + 8.D0*X**2 )
      CGG2 = CGG2 + XS12MM * (  - 16.D0 - 32.D0*X - 16.D0*X**2 )
      CGG2 = CGG2 - 32.D0 + 32.D0*X*LOGX*LOGXM - 32.D0*X*LOGX*LOGXM**2
     &     + 8.D0*X*LOGX*LOGXP - 16.D0*X*LOGX*LOGXP**2 - 64.D0*X*LOGX
     &     + 16.D0*X*LOGX**2*LOGXM + 24.D0*X*LOGX**2*LOGXP - 14.D0*X*
     &    LOGX**2 - 16.D0/3.D0*X*LOGX**3 + 120.D0*X*LOGXM - 32.D0*X*
     &    LOGXM**2 - 66.D0*X - 16.D0*X**2*LOGX*LOGXM - 32.D0*X**2*LOGX*
     &    LOGXM**2 - 8.D0*X**2*LOGX*LOGXP**2 + 105.D0*X**2*LOGX + 16.D0
     &    *X**2*LOGX**2*LOGXM + 12.D0*X**2*LOGX**2*LOGXP - 8.D0*X**2*
     &    LOGX**2 - 16.D0/3.D0*X**2*LOGX**3 - 134.D0*X**2*LOGXM + 48.D0
     &    *X**2*LOGXM**2 + 98.D0*X**2 + 4.D0*LOGX*LOGXM - 8.D0*LOGX*
     &    LOGXM**2 + 8.D0*LOGX*LOGXP - 8.D0*LOGX*LOGXP**2 - 23.D0*LOGX
     &     + 4.D0*LOGX**2*LOGXM + 12.D0*LOGX**2*LOGXP - 6.D0*LOGX**2 - 
     &    2.D0*LOGX**3 + 14.D0*LOGXM - 16.D0*LOGXM**2


      RETURN
      END

C THE ONE-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS1(RS,LAMBDA,NF)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,LAMBD2,NF
      PI=3.14159265359D0
      LAMBD2=LAMBDA*LAMBDA
      BF=(33.0D0-2.0D0*NF)/12.0D0/PI
      RS2=RS*RS
      DL1=DLOG(RS2/LAMBD2)
      ALFAS1=1.0D0/DL1/BF
      RETURN
      END
C THE TWO-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS2(RS,LAMBDA,NF)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,LAMBD2,NF
      PI=3.14159265359D0
      LAMBD2=LAMBDA*LAMBDA
      BF=(33.0D0-2.0D0*NF)/12.0D0/PI
      BFP=(153.0D0-19.0D0*NF)/(66.0D0-4.0D0*NF)/PI
      RS2=RS*RS
      DL1=DLOG(RS2/LAMBD2)
      DL2=DLOG(DL1)
      ALFAS2=(1.0D0-(BFP*DL2)/(BF*DL1))/DL1/BF
      RETURN
      END

C THE THREE-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS3(RS,LAMBDA,NFL)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,NFL
      PI=3.14159265359D0
      AL=2.0D0*DLOG(RS/LAMBDA)
      AL2=AL*AL
      AL3=AL2*AL
      BETA0=(11-2.0D0*NFL/3.0D0)/4.0D0
      BETA02=BETA0*BETA0
      BETA03=BETA02*BETA0
      B1=(102.0D0-38.0D0*NFL/3.0D0)/BETA0/16.0D0
      B2=(2857.0D0/2.0D0-5033.0D0*NFL/18.0D0
     1+325.0D0*NFL*NFL/54.0D0)/BETA0/64.0D0
      ALFAS3=PI*(1.0D0/BETA0/AL-B1*DLOG(AL)/BETA02/AL2
     2+(B1*B1*(DLOG(AL)**2.0D0-DLOG(AL)-1.0D0)+B2)
     3/BETA03/AL3)
      RETURN
      END

