      SUBROUTINE PARTON(XN,UN,DN,USN,DSN,SSN,CSN,BSN,TSN,GLN)
      IMPLICIT DOUBLE COMPLEX (A - Z)
      DOUBLE PRECISION 
     1          AUC(10), ADC(10), AUBC(10), ADBC(10), ASTC(10), AGC(10),
     2          ACHC(10), ABOC(10), EQUP, EQDO
       INTEGER IRES
C       COMMON / COUPL / ALPQR, LMQ, LMQR
        data auc / 9.1526E-02, -4.0245E-01,  3.6044E+00,  1.1957E+00,
     #            2.3896E+01, -2.3296E+01, 2.8161E+00,  3.2848E+03,
     #            1.8946E+01,  4.7582E+00/
        data adc / 9.7001E-02, -3.9720E-01,  5.6267E+00,  2.7094E-01,
     #           1.6305E+01,  1.5655E+01, 4.3386E+00, -4.8965E+04,
     #           1.7558E+01,  9.3461E+00 /
        data aubc / 1.2703E-01, -3.6978E-01,  6.9512E+00, -3.7603E+00,
     #             -1.5450E+00,  4.3864E+00,6.6625E-01,  9.0884E+00,
     #              1.1952E+01,  3.7389E+00/
*        data adbc / 5.9665E-04, -4.7458E-01,  1.5319E+01, -4.1333E+02,
*     #             1.0573E+03, -2.0000E+02, 4.4890E+00,  1.3895E-01,
*     #             8.6554E+00, -3.6193E-01 /
        data adbc / 7.7741E-03, -4.7148E-01,  1.5495E+01, -3.5088E+01,
     #             8.7956E+01,  1.7290E+09,3.4750E+01,  1.4257E-01,
     #             8.6757E+00, -3.4304E-01 /
        data astc / 1.0983E-01, -2.9281E-01,  2.6514E+01, -4.1408E+01,
     #             -1.5976E+01,  5.3258E+01,5.8360E-01,  5.7033E-02,
     #              7.9674E+00, -4.0298E-01/
        data achc / 1.1203E-01, -3.8187E-01,  1.0999E+01, -6.4292E+00,
     #             7.3183E+01,  5.0875E+02,1.2173E+01, -8.1784E+00,
     #             1.1128E+01,  7.0659E-01 /
        data aboc / 1.9306E-01, -3.4176E-01,  3.4566E+00,  1.1358E+00,
     #             -2.4801E-01, -1.8905E+00,1.7340E-01,  1.3567E+01,
     #              8.5639E+00,  1.3952E+01 /
        data agc /3.6895E+00, -3.7423E-01,  4.4780E+00,  2.7796E+01,
     #            3.6332E+00, -2.0575E+01,
     #            4.1412E-01, -4.3567E+01,  4.4762E+00,  3.8330E-01 /
C
C ... CTEQ5M:
C
        UN = CFN(XN, AUC)
        DN = CFN(XN, ADC)
        USN = CFN(XN, AUBC)
        DSN = CFN(XN, ADBC)
        SSN = CFN(XN, ASTC)
        CSN = CFN(XN, ACHC)
*        BSN = CFN(XN, ABOC)
        BSN = 0.
        TSN = 0.
        GLN = CFN(XN, AGC)
C

       RETURN
       END

      FUNCTION  CFN(XN,A)
      IMPLICIT DOUBLE COMPLEX (A-H,O-Z)
      DOUBLE PRECISION A(10)
c
      C1 = XN-1.+A(2)
      C2 = DCMPLX(A(3)+1.D0, 0.D0)
      C3 = XN-1.+A(10)
      C4 = DCMPLX(A(9)+1.D0, 0.D0)
      CB1 = CBETA(C1, C2)
      CB2 = CBETA(C1+0.5D0, C2)
      CB3 = CBETA(C1+1.D0, C2)
      CB4 = CBETA(C1+A(7), C2)
      CB5 = CBETA(C3, C4)
C     ---------------
C     PARAMETRISATION
C     ---------------
C     X^(N-1)*f(x)=A1*X^(N-1)*X^(A2-1)*(1-X)^A3*
C                             (1+A4*SQRT(X)+A5*X+A6*X^A7)
C                 +A8*X^(N-1)*X^(A10-1)*(1-x)^A9
      CFN = A(1)*(CB1 + A(4)*CB2 + A(5)*CB3 + A(6)*CB4) + A(8)*CB5
C
      RETURN
      END

C...BETA FUNCTION FOR COMPLEX ARGUMENT :
       DOUBLE COMPLEX FUNCTION CBETA (Z1, Z2)
       IMPLICIT DOUBLE COMPLEX (A - Z)
       LNGAM (X) = (X - 0.5) * LOG (X) - X + 0.91893853 + 1./(12.* X)
     1              * (1.- 1./(30.* X*X) * (1.- 1./(3.5 * X*X)
     2              * (1.- 4./(3.* X*X))))
       SUB = CMPLX (0., 0.)
       ZZ1 = Z1
  1    CONTINUE
       IF ( DREAL (ZZ1) .LT. 15.) THEN
          SUB = SUB + LOG ((ZZ1+Z2) / ZZ1)
          ZZ1 = ZZ1 + 1.
          GOTO 1
       END IF
       ZZ2 = Z2
  2    CONTINUE
       IF ( DREAL (ZZ2) .LT. 15.) THEN
          SUB = SUB + LOG ((ZZ1+ZZ2) / ZZ2)
          ZZ2 = ZZ2 + 1.
          GOTO 2
       END IF
       LG1 = LNGAM (ZZ1)
       LG2 = LNGAM (ZZ2)
       LG12 = LNGAM (ZZ1 + ZZ2)
       CBETA = EXP (LG1 + LG2 - LG12 + SUB)
       RETURN
       END
C
C

